note
	description: "Summary description for {RL_AWARE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_AWARE
feature
	c_ascending : INTEGER = 1
	as_utf8 (a_string : separate READABLE_STRING_GENERAL) : RL_STRING_UTF8
		do
			if attached {RL_STRING_UTF8} local_string(a_string) as al_string then
				create Result.make_from_separate(al_string)
			elseif attached {STRING_8} local_string(a_string) as al_string then
				create Result.make_from_string(create {STRING_8}.make_from_separate (al_string))
			elseif attached {STRING_32} local_string(a_string) as al_string then
				create Result.make_from_string_32 (create {STRING_32}.make_from_separate (al_string))
			else
				create Result.make_from_string_32 (create {STRING_32}.make_from_separate (a_string.as_string_32))
			end
		end
	as_string_32 (a_string : separate READABLE_STRING_GENERAL) : STRING_32
		local
			l_result : separate STRING_32
		do
			if attached {STRING_32} a_string as al_string then
				l_result := al_string
			elseif attached {STRING_8} a_string as al_string then
				if utf_converter.is_valid_utf_8_string_8 (al_string) then
					l_result := encoder.decoded_string(al_string)
				else
					l_result := encoder.decoded_string (encoder.encoded_string (al_string))
				end
			else
				l_result := a_string.as_string_32
			end
			create Result.make_from_separate (l_result)
		end
	local_string (a_string : separate READABLE_STRING_GENERAL) : READABLE_STRING_GENERAL
		do
			if attached {READABLE_STRING_GENERAL} a_string as al_string then
				Result := al_string
			else
				if attached {separate RL_STRING_UTF8} a_string as al_string then
					create {RL_STRING_UTF8} Result.make_from_separate(al_string)
				elseif attached {separate STRING_8} a_string as al_string then
					create {STRING_8} Result.make_from_separate(al_string)
				else
					create {STRING_32} Result.make_from_separate(a_string)
				end
			end
		end

	local_string_8 (a_string : separate STRING_8) : STRING_8
		do
			if attached {STRING_8} a_string as al_key then
				Result := al_key
			else
				create Result.make_from_separate(a_string)
			end
		end

	utf_converter : UTF_CONVERTER
		once
			create Result
		end
	encoder : UTF8_ENCODER
		once
			create Result
		end

	detachable_string_from_separate(a_string : detachable separate READABLE_STRING_8) : detachable STRING_8
		do
			if attached a_string as al_string then
				create Result.make_from_separate(al_string)
			end
		end

	string_from_separate(a_string :  separate READABLE_STRING_8) : STRING_8
		do
			create Result.make_from_separate(a_string)
		end


	detachable_string_32_from_separate(a_string : detachable separate READABLE_STRING_GENERAL) : detachable STRING_32
		do
			if attached a_string as al_string then
				create Result.make_from_separate(al_string)
			end
		end

	string_32_from_separate(a_string :  separate READABLE_STRING_GENERAL) : STRING_32
		do
			create Result.make_from_separate(a_string)
		end
	parsed_html (a_string : READABLE_STRING_GENERAL) : STRING_32
		local
			l_parser : RL_HTML_PARSER
			l_first,l_last : INTEGER
			l_head,l_tail,l_string : STRING_32
		do
			Result := as_string_32(a_string)
			if Result /~ ""
			and then Result.substring_index ("</", 1) > 0 then
				l_string := Result.twin
				l_string.prune_all('%U')
				l_first := l_string.index_of ('<', 1)
				l_last := l_string.last_index_of ('>', l_string.count)
				if l_first > 0 and then l_last > l_first then
					create l_parser.make
					l_parser.parse_from_string_32 (l_string.substring (l_first, l_last))
					if not l_parser.error_occurred then
						if l_first > 1 then
							l_head := l_string.substring (1, l_first - 1)
						else
							l_head := ""
						end
						if l_last < l_string.count then
							l_tail := l_string.substring (l_last + 1, l_string.count)
						else
							l_tail := ""
						end
						Result := l_head + l_parser.content + l_tail
					else
						Result := l_string
					end
				end
			end
		end

	arguments : ARGUMENTS_32
		once
			create Result
		end
feature -- Logging



	exceptions : EXCEPTIONS
		once
			create Result
		end

end
