note
	description: "Summary description for {RL_CONSENSUS_APPLICATION}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_ENLIS_APPLICATION
inherit
	RL_ENLIS_AWARE
	RL_ENLIS_ENDPOINTS
	RL_EXCEL_AWARE
create
	make,
	make_load,
	make_test_annual,
	make_update_dates
feature
	read_variables
		local
			l_file,l_output : RAW_FILE
			l_line : RL_DELIMITED_TEXT_32
			l_utf8 : RL_STRING_UTF8
			l_name : STRING_32
		do
			create l_file.make_open_read ("/Users/markhoward/Documents/compustat_variables.txt")
			create l_output.make_open_write ("/Users/markhoward/Documents/computstat_variables.e")
			from l_file.read_line until l_file.off loop
				create l_utf8.make_from_string (l_file.last_string)
				create l_line.make(l_utf8.to_string_32, '|')
				l_name := l_line[1]
				l_name.to_lower
				l_name.replace_substring_all (" ", "_")
				l_output.put_string (l_name + " := a_record." + l_line[2].as_lower + " * 1000%N" )
				l_file.read_line
			end
			l_output.close
		end
	make
		local
			l_records : RL_LIST[CAPIQ_NA_ANNUAL_RECORD]
			l_query : RL_POSTGRES_QUERY[CAPIQ_NA_ANNUAL_RECORD,TUPLE[STRING_8]]
			l_funda_query : RL_POSTGRES_QUERY[RL_GFUNDA_RECORD,TUPLE[STRING_32]]
			l_retrieved : RL_LIST[RL_GFUNDA_RECORD]
			l_wrds_query : RL_POSTGRES_QUERY[RL_ENLIS_FUNDA_RECORD,TUPLE[STRING_8,STRING_8]]
			l_lines : RL_DELIMITED_FILE
			l_file : RAW_FILE
			l_variables : HASH_TABLE[RL_ENLIS_VARIABLE,STRING_32]
			l_wrds_records : RL_LIST[RL_ENLIS_FUNDA_RECORD]
			l_date : RL_DATE
			l_combined : RL_COMBINED_STATEMENT
			l_ulisses : RL_ULISSES_STATEMENTS
			l_forecasts : RL_ENLIS_FORECASTS
			l_company : RL_ENLIS_COMPANY
		do
--			load_us_industries
--			create l_variables.make(1000)
--			create l_lines.make ("/Users/markhoward/taxonomy.txt","%T")
--			l_lines.apply (agent read_taxonomy(?,?,l_variables))
--			create l_file.make_open_write ("/Users/markhoward/taxonomy")
--			across l_variables as ic_variables loop
--				l_file.put_string (ic_variables.item.display + "%N")
--			end
--			l_file.close
--			create l_wrds_query.make (wrds, "select * from comp_na_annual_all.funda where tic = 'AAPL' and datadate = '2010-09-30'")
--			create l_wrds_query.make (wrds, "select * from comp_na_annual_all.funda where tic = $1 and datadate = $2")
--			create l_date.make (2010, 9, 30)
--			l_wrds_records := l_wrds_query.retrieved (["AAPL","2010-09-30"])
--			create l_query.make(capiq_server,"select * from capiq_na_annual where ticker = $1")
--			l_records := l_query.retrieved(["AAPL"])
			if is_load then
				make_load
			elseif arguments.index_of_word_option ("isins") > 0 then
				load_isins
			elseif arguments.index_of_word_option ("display") > 0 then
				make_statement
			elseif arguments.index_of_word_option ("ulisses") > 0 then
				make_ulisses
			elseif arguments.index_of_word_option ("compustat") > 0 then
				make_compustat
			elseif is_read then
				make_read
			elseif is_update_dates then
				make_update_dates
			elseif arguments.index_of_word_option ("retrieve") > 0 then
				make_retrieve
			elseif arguments.index_of_word_option ("relay_port") > 0 then
				make_relay
			elseif arguments.index_of_word_option ("utf8") > 0 then
				test_utf8
			elseif arguments.index_of_word_option ("test") > 0 then
				create l_company.make_from_barra ("UKIDHN1")
				create l_funda_query.make(barra,"select * from comp.g_funda where gvkey = $1 and final = 'Y' and fyear = 2018")
				l_retrieved := l_funda_query.retrieved([l_company.gvkey])
				create l_forecasts.make_barra_annual (l_company, False)
				create l_combined.make (l_forecasts, 2018)
				l_combined.save_global_bs (l_company.isin,2018,l_retrieved[1])
--				create l_ulisses.make (l_forecasts, 2018)
--				create l_statement.make("GLOBAL_INCOME_STATEMENT",l_ulisses)
--				l_statement.display (l_statement.items)
--			elseif arguments.index_of_word_option("reference") > 0 then
--				create l_company.make_from_localid (arguments.argument(arguments.index_of_word_option("reference") + 1))
--				print(l_company.gvkey + "%N")
			else
				make_test_annual
			end
		end
	make_relay
		local
			l_index : INTEGER
			l_relay : RL_RELAY
		do
			l_index := arguments.index_of_word_option (("relay_port").to_string_32)
			if l_index > 0
			and then arguments.argument_count > l_index
			and then arguments.argument (l_index + 1).is_integer then
				set_relay_port(arguments.argument (l_index + 1).to_integer)
			elseif relay_port = 0 then
				set_relay_port(0)
			end
			create l_relay.make (gateway,relay_port)
			l_relay.execute
		end
	test_utf8
		local
			l_foo : RL_JSON_NODE[ANY]
			l_item : READABLE_STRING_GENERAL
		do
			if attached {RL_JSON_STRING} l_foo as al_foo then
				l_item := al_foo.item
			end
		end
	gateway :  RL_ENLIS_GATEWAY attribute create Result.make end
	read_taxonomy(a_line : RL_DELIMITED_TEXT_8;a_index : INTEGER;a_variables : HASH_TABLE[RL_ENLIS_VARIABLE,STRING_32])
		local
			l_parent,l_variable : RL_ENLIS_VARIABLE
		do
			if a_line[3] /~ "" then
				l_parent := a_variables[a_line[3]]
			end
			if not attached l_parent then
				create l_parent.make ("", a_line[3], "", Void)
				a_variables[a_line[3]] := l_parent
			end
			l_variable := a_variables[a_line[2]]
			if attached l_variable then
				l_variable.make (a_line[1], a_line[2], a_line[4], l_parent)
			else
				create l_variable.make (a_line[1], a_line[2], a_line[4], l_parent)
				a_variables[a_line[2]] := l_variable
			end
		end
	find_final_excel_files (a_path,a_name : STRING_32;a_files : RL_LIST[TUPLE[path,name : STRING_32]])
		local
			l_offset : INTEGER
			l_directory : DIRECTORY
			l_path : STRING_32
		do
			if True then --a_path.substring_index ("Backup", 1) = 0 then
				l_path := file_path(<<a_path,a_name>>)
				if a_name.as_lower.substring_index (".xlsx", 1) > 0 then
					a_files.extend ([l_path,a_name])
				else
					create l_directory.make (l_path)
					if l_directory.exists then
						l_directory.open_read
						across l_directory.linear_representation as ic_files loop
							if not ic_files.item.starts_with(".") then
								find_final_excel_files(l_path,ic_files.item,a_files)
							end
						end
					end
				end
			end
		end
	use_ticker(a_ticker : STRING_8) : BOOLEAN
		do
			Result := tickers.is_empty
			or else tickers[a_ticker]
		end
	format_table : HASH_TABLE[INTEGER,STRING_32]
		attribute
			create Result.make (100)
		end
	add_format (a_format : RL_FORMAT_RECORD)
		do
			format_table[a_format.format] := a_format.id
		end
	entities : RL_ENTITIES once create Result.make end
	make_statement
		local
			l_security : RL_SECURITY
			l_arguments : RL_JSON_STRUCTURE
			l_ticker,l_category,l_key,l_minus : STRING_32
			l_items : ARRAY[STRING_32]
			l_assets,l_liabilities : RL_ULISSES_ITEM
			l_keyed : like entities.bloomberg_id_securities.item
			l_found : like entities.bloomberg_id_securities.search
			l_taxonomy : RL_COMPUSTAT_TAXONOMY
		do
			l_ticker := "AAPL_US"
			create l_keyed.make (l_ticker,l_security)
			l_found := entities.bloomberg_id_securities.search(l_keyed)
			create l_taxonomy
			across l_taxonomy.taxonomy_bs_na_annual as ic_taxonomy loop
				l_category := ic_taxonomy.key
				l_items := ic_taxonomy.item
				if attached l_taxonomy.mapping[l_category] as al_category then
					print(al_category + "%N")
					across l_items as ic_items loop
						l_key := ic_items.item
						if l_key[1] = '-' then
							l_minus := "-"
							l_key :=  l_key.substring (2, l_key.count)
						else
							l_minus := ""
						end
						if attached l_taxonomy.mapping[l_key] as al_item then
							print("%T" + l_minus  + al_item + "%N")
						else
							print("Unknown " + ic_items.item + "{%N")
						end
					end
				end
			end
--			across entities.securities as ic_securities loop
--				l_statements := statements(ic_securities.item)
--				across l_statements as ic_statements loop
--					l_statement := ic_statements.item
--					l_assets := l_statement.line_items[c_total_assets]
--					l_liabilities := l_statement.line_items["Total Assets and Shareholders Liability"]
--					if attached l_assets
--					and then not l_assets.is_consistent then
--						do_nothing
--					end
--					if attached l_liabilities
--					and then not l_liabilities.is_consistent then
--						do_nothing
--					end
--					if attached l_assets
--					and then attached l_liabilities
--					and then (l_assets.value - l_liabilities.value).abs > .01 then
--						do_nothing
--					end
--				end
--			end
		end

	c_total_assets : STRING_32 = "Total Assets"
	c_total_current_assets : STRING_32 = "Total Current Assets"
	c_total_noncurrent_assets : STRING_32 = "Total Noncurrent Assets"
	c_total_liabilities : STRING_32 = "Total Liabilities"
	c_total_current_liabilities : STRING_32 = "Total Current Liabilities"
	c_total_noncurrrent_liabilities : STRING_32 = "Total Noncurrent Liabilities"
	make_test_annual
		local
--			l_regression : REGRESSION
			l_eps_forecaster : RL_ENLIS_EPS_FORECASTER
			l_financial_statements : RL_ENLIS_FINANCIAL_STATEMENTS
			l_ratio_analysis : RL_ENLIS_RATIO_ANALYSIS
			l_cash_flow_analysis : RL_ENLIS_CASH_FLOW_ANALYSIS
			l_credit_analysis : RL_ENLIS_CREDIT_ANALYSIS
			l_residual : RL_ENLIS_RESIDUAL_INCOME_VALUATIONS
			l_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_balance_sheet : RL_ENLIS_BALANCE_SHEET
			l_year : INTEGER
			l_tax_shield_on_interest,l_forecasted_price_at_year_end,l_average_implied_default_probability : REAL_64
			l_value,l_sales,l_net_income,l_assets : REAL_64
			l_date : RL_DATE
			l_forecast : RL_ENLIS_FORECASTS
			l_apple : RL_NA_COMPANY
			l_tsm,l_company : RL_ENLIS_COMPANY
			l_computation : RL_ENLIS_DOUBLE_COMPUTATION
			l_valuation_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_file : RAW_FILE
			l_record : RL_GVKEY_IBTIC_RECORD
			l_id_query : RL_POSTGRES_QUERY[RL_ENLIS_BARRID_RECORD,TUPLE[STRING_8]]
			l_id_record : RL_ENLIS_BARRID_RECORD
			l_retrieved : RL_LIST[RL_ENLIS_BARRID_RECORD]
			l_nodes : RL_LIST[RL_GRAPH_NODE]
			l_links : RL_LIST[RL_GRAPH_LINK]
			l_request_handler : RL_ENLIS_REQUEST
			l_arguments : RL_JSON_STRUCTURE
			i : INTEGER
			l_cohorts : like industry_cohorts
			l_cohort : like industry_cohorts.item
			l_revenues : like sales_query.retrieved
			l_tickers,l_barras : STRING_32
			l_vector : RL_VECTOR
			l_values : RL_LIST[REAL_64]
			l_moments : RL_MOMENTS
--			l_regression : REGRESSION
		do
			create l_date.make (2018, 6, 1)
			l_cohorts := industry_cohorts("USE3S_BIOTECH",l_date)
			l_tickers := "{"
			l_barras := "{"
			across l_cohorts as ic_cohorts loop
				l_cohort := ic_cohorts.item
				if l_barras /~ "{" then
					l_barras.append (",")
				end
				l_barras.append ("%"" +l_cohort.barrid + "%"")
			end
			l_barras.append ("}")
			l_retrieved := barra_from_barras_query.retrieved([l_barras])
			across l_retrieved as ic_barras loop
				l_id_record := ic_barras.item
				if l_id_record.localid /~ "" then
					if l_tickers /~ "{" then
						l_tickers.append (",")
					end
					l_tickers.append ("%"" + l_id_record.localid + "%"")
				end
			end
			l_tickers.append ("}")
			l_revenues := sales_query.retrieved ([l_tickers,l_date.year.to_double])
			create l_values
			across l_revenues as ic_revenues loop
				l_values.extend (ic_revenues.item.sale)
			end
			create l_vector.make_from_list (l_values)
			create l_company.make_from_barra("USAB1X1")
			create l_forecast.make_barra_annual (l_company,True)
			l_nodes := l_forecast.financial_statements_table[2019].income_taxes_payable.graph_nodes
			l_links := l_forecast.financial_statements_table[2019].income_taxes_payable.graph_links
			create l_file.make_open_write ("/Users/markhoward/lifecycle.csv")
			from i := 2014 until i > 2023 loop
				l_financial_statements := l_forecast.financial_statements_table[i]
--				l_nodes := l_forecast.graph_nodes
--				l_links := l_forecast.graph_links
				l_sales := l_financial_statements.sales_net.value
				l_net_income := l_financial_statements.net_income.value
				l_assets := l_financial_statements.total_assets.value
				l_file.put_string ((l_sales / l_assets).out + "," + (l_net_income / l_sales).out + "%N")
				i := i + 1
			end
			l_file.close
			l_forecast.panel.do_nothing
			l_id_record := barra_from_barra_query.witness (["ARGANX1"])
			create l_tsm.make_from_barra ("ARGANX1")
			l_record := ids_from_ibtic("@FCT")
			l_record := ids_from_gvkey("201395")
			create l_date.make_today
--			create l_apple.make ("AAPL")
--			create l_valuation_parameters.make (l_apple, 2015, 5, l_date)
--			create l_forecast.make_barra_na (l_valuation_parameters)
--			l_forecast.panel.do_nothing
--			create l_tsm.make ("201395","@FCT")
			create l_tsm.make_from_barra("TAIBHH1")
			create l_valuation_parameters.make_annual (l_tsm, l_date.year, 4, l_date)
			create l_forecast.make_barra_annual (l_tsm,True)
--			create l_forecast.make_enlis (l_company, l_date,5866161,2019)
--			create l_file.make_open_write ("/Users/markhoward/statement_aapl_2010.txt")
--			across l_forecast.financial_statements_table[2010].computations as ic_computations loop
--				l_file.put_string (ic_computations.key + "%T" + ic_computations.item.item.value.out + "%N")
--			end
--			l_file.close
--			l_computation := l_forecast.ratio_analysis_table[2015].sales
			from l_year := l_date.year until l_year > l_date.year + 4 loop
				l_residual := l_forecast.residual_income_valuations_table[l_year]
				l_value := l_residual.approximate_cost_of_capital.value
--				l_value := l_forecast.financial_statements_table[i].minority_interest_in_earnings.value
--				l_new_value := l_forecast.forecasting_assumptions_table[i].cost_of_goods_sold_sales.value
				l_computation := l_forecast.dcf_valuations_table[l_year].present_value_beyond_n_years
				l_value := l_forecast.cash_flow_analysis_table[l_year].gross_cash_flow.value
				l_value := l_forecast.ratio_analysis_table[l_year].sales.value
				l_forecasted_price_at_year_end := l_forecast.eps_forecaster_table[l_year].forecasted_price_at_year_end.value
				l_average_implied_default_probability := l_forecast.credit_analysis_table[l_year].average_implied_default_probability.value
				l_value := l_forecast.credit_analysis_table[l_year].annual_sales_growth.value
				l_value := l_forecast.cash_flow_analysis_table[2015].capital_expenditures.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_77.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_86.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_97.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_116.value
				l_year := l_year + 1
			end
		end
	cohort_query : RL_POSTGRES_QUERY[RL_INDUSTRY_EXPOSURE,TUPLE[variable,date : STRING_32]]
		once
			create Result.make(barra,"[
				select barrid,datadate,factor as industry,exposure 
				from use3s_100_asset_exposure where datadate = $1 and factor = $2
			]")
		end
	sales_query : RL_POSTGRES_QUERY[RL_SALES_RECORD,TUPLE[gvke : STRING_32;date : REAL_64]]
		once
			create Result.make(barra,"[
				select tic,datadate,sale from comp.funda where tic = ANY($1) and fyear = $2 and final = 'Y'
			]")
		end
	industry_cohorts (a_industry : STRING_32;a_date : RL_DATE) : RL_LIST[RL_INDUSTRY_EXPOSURE]
		do
			Result := cohort_query.retrieved([a_date.iso_out,a_industry])
		end

--	update_variable_distributions(a_industry,a_variable : STRING_32;a_date : RL_DATE)
--		local
--			l_command : RL_POSTGRES_COMMAND[TUPLE[industry,variable,date : STRING_32;mean,stdev,kurtosis,skew : REAL_64]]
--		do
--			create l_query.make(barra,
--		end

	make_test_quarterly
		local
			l_eps_forecaster : RL_ENLIS_EPS_FORECASTER
			l_financial_statements : RL_ENLIS_FINANCIAL_STATEMENTS
			l_ratio_analysis : RL_ENLIS_RATIO_ANALYSIS
			l_cash_flow_analysis : RL_ENLIS_CASH_FLOW_ANALYSIS
			l_credit_analysis : RL_ENLIS_CREDIT_ANALYSIS
			l_residual : RL_ENLIS_RESIDUAL_INCOME_VALUATIONS
			l_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_balance_sheet : RL_ENLIS_BALANCE_SHEET
			l_year : INTEGER
			l_tax_shield_on_interest,l_forecasted_price_at_year_end,l_average_implied_default_probability : REAL_64
			l_value,l_sales,l_net_income,l_assets : REAL_64
			l_date : RL_DATE
			l_forecast : RL_ENLIS_FORECASTS
			l_apple : RL_NA_COMPANY
			l_tsm,l_company : RL_ENLIS_COMPANY
			l_computation : RL_ENLIS_DOUBLE_COMPUTATION
			l_valuation_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_file : RAW_FILE
			l_record : RL_GVKEY_IBTIC_RECORD
			l_id_query : RL_POSTGRES_QUERY[RL_ENLIS_BARRID_RECORD,TUPLE[STRING_8]]
			l_id_record : RL_ENLIS_BARRID_RECORD
			l_retrieved : RL_LIST[RL_ENLIS_BARRID_RECORD]
			l_nodes : RL_LIST[RL_GRAPH_NODE]
			l_links : RL_LIST[RL_GRAPH_LINK]
			l_request_handler : RL_ENLIS_REQUEST
			l_arguments : RL_JSON_STRUCTURE
			i : INTEGER
		do
			create l_company.make_from_barra("USAB1X1")
			create l_forecast.make_barra_quarterly (l_company,True)
			l_nodes := l_forecast.financial_statements_table[2019 * 4 + 1].income_taxes_payable.graph_nodes
			l_links := l_forecast.financial_statements_table[2019 * 4 + 1].income_taxes_payable.graph_links
			create l_file.make_open_write ("/Users/markhoward/lifecycle.csv")
			from i := 2014 * 4 + 1 until i > 2023 * 4 + 4 loop
				l_financial_statements := l_forecast.financial_statements_table[i]
--				l_nodes := l_forecast.graph_nodes
--				l_links := l_forecast.graph_links
				l_sales := l_financial_statements.sales_net.value
				l_net_income := l_financial_statements.net_income.value
				l_assets := l_financial_statements.total_assets.value
				l_file.put_string ((l_sales / l_assets).out + "," + (l_net_income / l_sales).out + "%N")
				i := i + 1
			end
			l_file.close
			l_forecast.panel.do_nothing
			l_id_record := barra_from_barra_query.witness (["ARGANX1"])
			create l_tsm.make_from_barra ("ARGANX1")
			l_record := ids_from_ibtic("@FCT")
			l_record := ids_from_gvkey("201395")
			create l_date.make_today
--			create l_apple.make ("AAPL")
--			create l_valuation_parameters.make (l_apple, 2015, 5, l_date)
--			create l_forecast.make_barra_na (l_valuation_parameters)
--			l_forecast.panel.do_nothing
--			create l_tsm.make ("201395","@FCT")
			create l_tsm.make_from_barra("TAIBHH1")
--			create l_valuation_parameters.make (l_tsm, l_date.year, 4, l_date)
			create l_forecast.make_barra_quarterly (l_tsm,True)
--			create l_forecast.make_enlis (l_company, l_date,5866161,2019)
--			create l_file.make_open_write ("/Users/markhoward/statement_aapl_2010.txt")
--			across l_forecast.financial_statements_table[2010].computations as ic_computations loop
--				l_file.put_string (ic_computations.key + "%T" + ic_computations.item.item.value.out + "%N")
--			end
--			l_file.close
--			l_computation := l_forecast.ratio_analysis_table[2015].sales
			from l_year := l_date.quarter until l_year > l_date.quarter + 14 loop
				l_residual := l_forecast.residual_income_valuations_table[l_year]
				l_value := l_residual.approximate_cost_of_capital.value
--				l_value := l_forecast.financial_statements_table[i].minority_interest_in_earnings.value
--				l_new_value := l_forecast.forecasting_assumptions_table[i].cost_of_goods_sold_sales.value
				l_computation := l_forecast.dcf_valuations_table[l_year].present_value_beyond_n_years
				l_value := l_forecast.cash_flow_analysis_table[l_year].gross_cash_flow.value
				l_value := l_forecast.ratio_analysis_table[l_year].sales.value
				l_forecasted_price_at_year_end := l_forecast.eps_forecaster_table[l_year].forecasted_price_at_year_end.value
				l_average_implied_default_probability := l_forecast.credit_analysis_table[l_year].average_implied_default_probability.value
				l_value := l_forecast.credit_analysis_table[l_year].annual_sales_growth.value
				l_value := l_forecast.cash_flow_analysis_table[2015 * 4 + 1].capital_expenditures.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_77.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_86.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_97.value
				l_value := l_forecast.cash_flow_analysis_table[l_year].free_cash_flow_to_investors_116.value
				l_year := l_year + 1
			end
		end
	make_retrieve
		local
			l_query : RL_POSTGRES_QUERY[CAPIQ_GLOBAL_ANNUAL_RECORD,TUPLE]
			l_retrieved : RL_LIST[CAPIQ_GLOBAL_ANNUAL_RECORD]
			l_timer : RL_PROCESS_TIMER
		do
			create l_query.make(capiq_server,"select * from capiq_global_annual")
			create l_timer
			l_retrieved := l_query.retrieved([])
			l_timer.display("retrieved " + l_retrieved.count.out + "%N")
		end
	make_load
		local
			l_workbook : RL_EXCEL_BOOK
			l_record : RL_CONSENSUS_SHEET_RECORD
			l_timer,l_ticker_timer : RL_PROCESS_TIMER
			l_ticker,l_name : STRING_8
			l_sheet_name : STRING_32
			l_count,l_offset, l_processed : INTEGER
			l_files : RL_LIST[TUPLE[path,name : STRING_32]]
			i : INTEGER
			l_file_name : FILE_NAME
			l_list : ARRAYED_LIST[STRING_32]
			l_process : BASE_PROCESS
			l_directory : DIRECTORY
			l_sheet : RL_EXCEL_SHEET
			l_csv : STRING_32
			l_success : BOOLEAN
		do
			create l_timer
			create l_files
			create l_file_name.make_temporary_name
			print(l_file_name.out + "%N")
			create l_directory.make (l_file_name.out)
			l_directory.create_dir
			format_query.apply (agent add_format, Void)
			checksum_query.apply(agent add_checksum, Void)
--			find_final_excel_files(source_directory,"",l_files)
			create l_workbook.make ("/Users/markhoward/Documents/randlabs/AAPL BASE Case.xlsx", l_file_name.out)
			debug("excel")
				l_workbook.prettify_all
			end
			if not l_workbook.failed then
				l_success := False
				across l_workbook.sheets as ic_sheets loop
					l_sheet := ic_sheets.item
					l_sheet_name := l_sheet.sheet_name.as_lower
					l_sheet_name.prune_all ('_')
					l_sheet_name.prune_all ('-')
					if true then --(l_sheet_name.substring_index("wlink",1) > 0 or else l_sheet.sheet_name.as_lower ~ "consensus") then
						if not checksums[l_sheet.checksum] then
							l_workbook.parse
							l_count := l_workbook.count_cell.item
							l_sheet.load_from_xml
							load_sheet(enlis_access,"AAPL BASE Case.xlsx",l_workbook,l_sheet,"AAPL","","USA")
							l_timer.display_nl ("Total")
							l_success := True
						else
							l_success := True
						end
					end
				end
			end
--			if l_workbook.failed or else not l_success then
--				print("failed to load " + l_ticker + "%N")
--			end
--			remove_directory(l_file_name.out)
			l_timer.display ("Done%N")
		end

	make_ulisses
		local
			l_workbook : RL_EXCEL_BOOK
			l_record : RL_CONSENSUS_SHEET_RECORD
			l_timer,l_ticker_timer : RL_PROCESS_TIMER
			l_barrid : STRING_8
			l_count,l_offset, l_processed,i : INTEGER
			l_files : RL_LIST[TUPLE[path,name : STRING_32]]
			l_file_name : FILE_NAME
			l_list : ARRAYED_LIST[STRING_32]
			l_process : BASE_PROCESS
			l_directory,l_source : DIRECTORY
			l_sheet : RL_EXCEL_SHEET
			l_filename,l_path,l_ticker,l_bloomberg_ticker,l_bloomberg_iso,l_iso,l_sheet_name : STRING_32
			l_success : BOOLEAN
			l_barra : RL_LIST[RL_ENLIS_BARRID_RECORD]
		do
			create l_timer
			create l_files
			create l_file_name.make_temporary_name
			print(l_file_name.out + "%N")
			create l_directory.make (l_file_name.out)
			l_directory.create_dir
			ulisses_access.format_query.apply (agent add_format, Void)
			ulisses_access.checksum_query.apply(agent add_checksum, Void)
--			find_final_excel_files(source_directory,"",l_files)
			create l_source.make_open_read ("/Users/markhoward/bloomberg")
			across l_source.entries as ic_paths loop
				if not ic_paths.item.name.starts_with (".") then
					l_filename := ic_paths.item.name
					if l_filename.starts_with ("ARD_DATA_") then
						l_bloomberg_ticker := l_filename.substring (10, l_filename.count-12).as_upper
					else
						l_bloomberg_ticker := l_filename.substring (1, l_filename.count-12).as_upper
					end
					l_offset := l_bloomberg_ticker.index_of('_',1)
					l_iso :=  ""
					l_bloomberg_iso := l_bloomberg_ticker.substring (l_offset + 1, l_bloomberg_ticker.count)
					if attached bloomberg_iso[l_bloomberg_iso] as al_iso then
						l_iso := al_iso
					end
					l_ticker := l_bloomberg_ticker.substring(1,l_offset - 1)
					l_barra := barra_from_localid_country_query.retrieved([l_ticker,l_iso])
					if attached l_barra.first as al_first then
						l_barrid := al_first.barrid
						print(l_filename + "%N")
					else
						l_barrid := ""
						print("missing " + l_filename + "%N")
					end
					create l_workbook.make ("/Users/markhoward/bloomberg/" + l_filename, l_file_name.out)
					debug("excel")
						l_workbook.prettify_all
					end
					if not l_workbook.failed then
						l_success := False
						print(l_filename)
						across l_workbook.sheets as ic_sheets loop
							l_sheet := ic_sheets.item
							l_sheet_name := l_sheet.sheet_name.as_lower
							l_sheet_name.prune_all ('_')
							l_sheet_name.prune_all ('-')
							if not checksums[l_sheet.checksum] then
								l_workbook.parse
								l_count := l_workbook.count_cell.item
								l_sheet.load_from_xml
								load_sheet(ulisses_access,l_filename,l_workbook,l_sheet,l_bloomberg_ticker,l_barrid,l_iso)
								l_success := True
							else
								l_success := True
							end
						end
						print("%N")
					end
				end
			end
			ulisses_access.server.execute ("[
				insert into statements(row_index,barrid,ticker,end_date,variable,value,country,sheet,sheet_id)
				select c.rowindex,a.barrid,a.ticker,cast(b.value as date) as end_date,c.value as variable,cast(d.value as float8) as value,iso,a.sheetname,a.id from
				sheets a,factvalue b,factvalue c,factvalue d where
				a.id = b.sheetid
				and d.value ~ '^[0-9.]*$'
				and a.id = c.sheetid
				and a.id = d.sheetid 
				and b.columnindex = d.columnindex
				and b.rowindex = 5
				and c.rowindex = d.rowindex
				and c.columnindex = 1
				and d.columnindex > 1
				and d.rowindex > 5
			]")
			load_isins
			l_timer.display ("Done%N")
		end

--	make_compustat_na
--		local
--			l_company : RL_ENLIS_COMPANY
--			l_funda_query : RL_POSTGRES_QUERY[RL_FUNDA_RECORD,TUPLE[STRING_32,INTEGER]]
--			l_retrieved : RL_LIST[RL_FUNDA_RECORD]
--			l_combined : RL_COMBINED_STATEMENT
--			l_forecasts : RL_ENLIS_FORECASTS
--			l_processed : HASH_TABLE[BOOLEAN,STRING_8]
--			l_barrid : STRING_8
--		do
--			create l_processed.make (100)
--			create l_funda_query.make(barra,"select * from comp.funda where tic = $1 and final = 'Y' and fyear = $2")
--			across bloomberg_barrids_na as ic_barrids loop
--				l_barrid := ic_barrids.item.barrid
--				if not l_processed[l_barrid] then
--					l_processed[l_barrid] := True
--					print(l_barrid + "%N")
--				end
--				create l_company.make_from_barra (ic_barrids.item.barrid)
--				if l_company.ticker /~ ("").as_string_32 then
--					l_retrieved := l_funda_query.retrieved([l_company.ticker,ic_barrids.item.year])
--					if l_retrieved.count > 0 then
--						create l_forecasts.make_barra_annual (l_company, False)
--						create l_combined.make (l_forecasts, ic_barrids.item.year)
--						l_combined.save_na (l_company.barrid,ic_barrids.item.year,l_retrieved[1])
--					else
--						print("Missing data for " + l_company.ticker + " for " + ic_barrids.item.year.out + "%N")
--					end
--				else
--					print("missing ticker for " + ic_barrids.item.barrid + "%T" + l_company.gvkey + "%N")
--				end
--			end
--		end

	load_isins
		local
			l_path : FILE_NAME
			l_output : RL_DELIMITED_FILE[TUPLE[barra_issuer_id : INTEGER;issue_name,barrid,isin,ticker,country :STRING_32;first,last : RL_DATE]]
			l_bloomberg_query : RL_POSTGRES_QUERY[RL_ENLIS_BARRID_RECORD,TUPLE]
			l_isin_query : RL_POSTGRES_QUERY[RL_ENLIS_BARRID_RECORD,TUPLE]
			l_bloomberg : RL_LIST[RL_ENLIS_BARRID_RECORD]
			l_id_records : RL_LIST[RL_ENLIS_BARRID_RECORD]
			l_id_record : RL_ENLIS_BARRID_RECORD
			l_tickers : STRING_32
		do
			create l_bloomberg_query.make(ulisses_access.server,"[
				select distinct substring(a.ticker,1,length(a.ticker)-3) as localid,b.iso as country_of_q_id
				from sheets a,bloomberg_countries b 
				where b.bloomberg_iso = substring(a.ticker,length(a.ticker)-1,length(a.ticker))
				and substring(a.ticker,1,length(a.ticker)-3) not in (select ticker from identifiers)
			]")
			l_bloomberg := l_bloomberg_query.retrieved([])
			l_tickers := "("
			across l_bloomberg as ic_bloomberg loop
				if ic_bloomberg.cursor_index > 1 then
					l_tickers.append (",")
				end
				l_tickers.append ("array['" + ic_bloomberg.item.localid + "','" + ic_bloomberg.item.country_of_q_id +"']")
			end
			l_tickers.append (")")
			create l_isin_query.make(barra,"[
				select distinct c.barra_issuer_id,c.issue_name,a.localid,c.country_of_q_id,b.isin,b.barrid,b.startdate,b.enddate 
				from localid_master a,isin_master b, equityidentity_master c 
				where c.barrid = a.barrid and a.barrid = b.barrid 
				and a.enddate > '2040-01-01'
				and array[cast (a.localid as text),c.country_of_q_id] in
				]" + l_tickers
				)
			create l_path.make_temporary_name
			print("Identifiers : " + l_path.string + "%N")
			create l_output.make (l_path.string, "%T")
			l_output.open_write
			l_id_records := l_isin_query.retrieved ([])--[l_barrid])
			across l_id_records as ic_ids loop
				l_id_record := ic_ids.item
				l_output.put_row ([l_id_record.barra_issuer_id,l_id_record.issue_name,l_id_record.barrid,l_id_record.isin,l_id_record.localid,l_id_record.country_of_q_id,l_id_record.first,l_id_record.last])
			end
			l_output.close
			ulisses_access.server.execute("copy identifiers (barra_issuer_id,issue_name,barrid,isin,ticker,country,first,last) from '" + l_path.string + "'")
		end

	make_compustat
		local
			l_path : FILE_NAME
			l_output : RL_DELIMITED_FILE[TUPLE[barrid,ticker,country,isin :STRING_32;first,last : RL_DATE]]
			l_statement_output : like statement_output_template
			l_company : RL_ENLIS_COMPANY
			l_id_records : like barra_isin_local_query.retrieved
			l_id_record : like barra_isin_local_query.witness
			l_funda_query :  RL_POSTGRES_QUERY[RL_FUNDA_RECORD,TUPLE[STRING_32,INTEGER]]
			l_gfunda_query : RL_POSTGRES_QUERY[RL_GFUNDA_RECORD,TUPLE[STRING_32,INTEGER]]
--			l_fundq_query :  RL_POSTGRES_QUERY[RL_FUNDQ_RECORD,TUPLE[STRING_32,INTEGER,INTEGER]]
--			l_gfundq_query : RL_POSTGRES_QUERY[RL_FUNDQ_RECORD,TUPLE[STRING_32,INTEGER,INTEGER]]
			l_bloomberg_query : RL_POSTGRES_QUERY[RL_BLOOMBERG_STATEMENT_RECORD,TUPLE]
			l_record : RL_BLOOMBERG_STATEMENT_RECORD
			l_ids : RL_ENLIS_BARRID_RECORD
			l_retrieved_na : RL_LIST[RL_FUNDA_RECORD]
			l_retrieved_global : RL_LIST[RL_GFUNDA_RECORD]
			l_bloomberg : RL_LIST[RL_BLOOMBERG_STATEMENT_RECORD]
			l_combined : RL_COMBINED_STATEMENT
			l_forecasts : RL_ENLIS_FORECASTS
			l_record_table : HASH_TABLE[RL_LIST[RL_BLOOMBERG_STATEMENT_RECORD],STRING_32]
			l_record_list : RL_LIST[RL_BLOOMBERG_STATEMENT_RECORD]
			l_ranges : RL_LIST[TUPLE[first,last : RL_DATE;barrid,isin : STRING_32]]
			l_year,l_month,l_quarter : INTEGER
			l_date : RL_DATE
			l_barrid,l_ticker : STRING_8
		do
			create l_bloomberg_query.make(ulisses_access.server,"[
				select distinct a.barrid,a.sheet,a.sheet_id,a.ticker,a.end_date,b.isin,b.country
				from statements a, identifiers b 
				where a.barrid = b.barrid
				and b.first <= a.end_date
				and a.end_date <= b.last
				and a.sheet like '%%_Y'
				]")
			create l_record_table.make (1000)
			l_bloomberg := l_bloomberg_query.retrieved([])
			create l_funda_query.make(barra,"select * from comp.funda where tic = $1 and final = 'Y' and fyear = $2")
			create l_gfunda_query.make(barra,"select * from comp.g_funda where isin = $1 and final = 'Y' and fyear = $2")
--			create l_fundq_query.make(barra,"select * from comp.fundq where tic = $1 and final = 'Y' and fyr = $2 and fqtr = $3")
--			create l_gfunq_query.make(barra,"select * from comp.g_fundq where isin = $1 and final = 'Y' and fyr = $ and fqtr = $3")
			create l_path.make_temporary_name
			across l_bloomberg as ic_records loop
				l_record := ic_records.item
				l_record_list := l_record_table[l_record.ticker]
				if not attached l_record_list then
					create l_record_list
					l_record_table[l_record.ticker] := l_record_list
				end
				l_record_list.extend (l_record)
			end
			across l_record_table as ic_records loop
				create l_path.make_temporary_name
				create l_statement_output.make(l_path.string,"%T")
				l_statement_output.open_write
				l_record_list := ic_records.item
				print(ic_records.key + "%T" + l_record_list.count.out + "%T" + l_path.string.out + "%N")
				across l_record_list as ic_statements loop
					l_record := ic_statements.item
					l_year := l_record.end_date.year
					l_month := l_record.end_date.month
					l_quarter := 0
					if l_record.sheet.ends_with("_Q") then
						l_quarter := l_month // 4 + 1
					end
					if l_record.country.as_string_8 ~ "USA"
					or else l_record.country.as_string_8 ~ "CAN" then
						if l_record.sheet.ends_with("_Y") then
							l_retrieved_na := l_funda_query.retrieved([l_record.ticker,l_year])
							if l_retrieved_na.count > 0 then
								save_na (l_statement_output,l_record,l_retrieved_na[1])
							else
								print("Missing data for " + l_record.ticker + " for " + l_record.barrid + "," + l_year.out + "%N")
							end
	--					else
	--						l_retrieved_na_quarterly := l_fundq_query.retrieved([l_record.ticker,l_year,l_quarter])
	--						if l_retrieved_na.count > 0 then
	--							save_na_quarterly (l_record,l_retrieved_na_quarterly[1])
	--						else
	--							print("Missing data for " + l_record.ticker + " for " + l_record.barrid + "," + l_year.out + "%N")
	--						end
						end
					else
						if l_record.sheet.ends_with("_Y") then
							l_retrieved_global := l_gfunda_query.retrieved([l_record.isin,l_year])
							if l_retrieved_global.count > 0 then
								save_global (l_statement_output,l_record,l_retrieved_global[1])
							else
								print("Missing data for " + l_record.isin + " for " + l_record.barrid + "," + l_year.out + l_quarter.out +"%N")
							end
	--					else
	--						l_retrieved_global_quarterly := l_gfundq_query.retrieved([l_record.isin,l_year,l_quarter])
	--						if l_retrieved_global_quarterly.count > 0 then
	--							save_global_quarterly (l_record,l_retrieved_global_quarterly[1])
	--						else
	--							print("Missing data for " + l_record.isin + " for " + l_record.barrid + "," + l_year.out + l_quarter.out + "%N")
	--						end
						end
					end
				end
				l_statement_output.close
				ulisses_access.server.execute("copy statements (barrid,sheet,ticker,country,sheet_id,end_date,mnemonic,value) from '" + l_path.string + "'")
			end
		end

	bloomberg_statements : STRING_32 = "[
					select a.barrid,a.ticker,b.value as fiscal,c.value as variable,cast(d.value as float8) as value from
					sheets a,factvalue b,factvalue c,factvalue d where
					a.id = b.sheetid
					and d.value ~ '^[0-9.]*$'
					and a.id = c.sheetid
					and a.id = d.sheetid 
					and b.columnindex = d.columnindex
					and b.rowindex = 4
					and c.rowindex = d.rowindex
					and c.columnindex = 1
					and d.columnindex > 1
					and d.rowindex > 5
					]"

	factory : BASE_PROCESS_FACTORY
		once
			create Result
		end

	remove_directory (a_name : STRING_8)
		local
			l_list : ARRAYED_LIST[STRING_8]
			l_process : BASE_PROCESS
		do
			if arguments.index_of_word_option ("preserve") = 0 then
				print("Removing " + a_name + "%N")
				create l_list.make_from_array(<<"-R",a_name>>)
				l_process := factory.process_launcher (rm_command,l_list,Void)
				l_process.launch
				l_process.wait_for_exit
			end
		end
	checksums : HASH_TABLE[BOOLEAN,STRING_8] attribute create Result.make(1000) end
	add_checksum (a_record : RL_CONSENSUS_SHEET_RECORD)
		do
			checksums[a_record.filechecksum] := True
		end
	load_sheet(a_access : RL_EXCEL_ACCESS;a_filename : STRING_8;a_book : RL_EXCEL_BOOK;a_sheet : RL_EXCEL_SHEET;a_ticker,a_barrid,a_iso : STRING_8)
		local
			l_indents,l_parents : HASH_TABLE[INTEGER,INTEGER]
			l_output : RL_DELIMITED_FILE[TUPLE[consensus_id,row,column,format : INTEGER;formula,value:STRING_8;column_letter,key : STRING_8]]
			l_row_file : RL_DELIMITED_FILE[TUPLE[consensus_id,index,parent,is_hidden : INTEGER]]
			l_column_file :  RL_DELIMITED_FILE[TUPLE[consensus_id : INTEGER;letter : STRING_8;is_hidden : INTEGER]]
			i,l_top,l_left,l_column,l_indent,l_is_hidden,l_offset,l_format_id,l_row_index,l_column_index,l_first_visible : INTEGER
			l_process : BASE_PROCESS
			l_factfile_name,l_rowfile_name,l_columnfile_name,l_loadfile_name,l_column_letter,l_merge,l_key : STRING_8
			l_load_file : RAW_FILE
			l_list : ARRAYED_LIST[STRING_8]
			l_row_indents : HASH_TABLE[INTEGER,INTEGER]
			l_row : RL_EXCEL_ROW
			l_horizontal,l_updated,l_period,l_format,l_value : STRING_32
			l_start,l_end : like row_column
			l_range : TUPLE[row,first,last : INTEGER;first_letter,last_letter : STRING_8;value :  STRING_32]
			l_ranges : RL_LIST[TUPLE[row,first,last : INTEGER;first_letter,last_letter : STRING_8;value :  STRING_32]]
			l_is_empty : BOOLEAN
			l_result : POINTER
			l_id : TUPLE[id : INTEGER]
			l_sheet_id : INTEGER
			l_rows,l_columns,l_hidden : HASH_TABLE[INTEGER,INTEGER]
			l_copy_command : RL_POSTGRES_COMMAND[TUPLE]
			l_fix,l_failed : BOOLEAN
		do
			if not l_failed then
				create l_row_indents.make (1000)
				print("%T"+ a_sheet.sheet_name)
				l_id := a_access.excel_sheet_command.witness ([a_filename,a_sheet.sheet_name,a_barrid,a_ticker,a_sheet.checksum,a_sheet.workbook.is_date1904,a_iso])
				l_sheet_id := l_id.id
				checksums[a_sheet.checksum] := True
				l_factfile_name := file_path(<<a_book.xml_path,a_sheet.sheet_name + "_factvalue.csv">>)
				l_rowfile_name := file_path(<<a_book.xml_path,a_sheet.sheet_name + "_rows.csv">>)
				l_columnfile_name := file_path(<<a_book.xml_path,a_sheet.sheet_name + "_columns.csv">>)
				create l_rows.make (a_sheet.column_count)
				create l_hidden.make (a_sheet.column_count)
				create l_columns.make (a_sheet.rows.count)
				create l_output.make (l_factfile_name,"%T")
				l_output.open_write
				l_updated := ""
				l_period := ""
				create l_ranges
				across a_sheet.columns as ic_columns loop
					from i := ic_columns.item.min until i > ic_columns.item.max loop
						l_hidden[i] := ic_columns.item.is_hidden
						if l_hidden[i] = 1 then
							l_first_visible := i
						end
						i := i + 1
					end
				end
				across a_sheet.cells as ic_cells loop
					l_format_id := 0
					l_format := Void
					l_fix := False
					if attached ic_cells.item as al_cell then
						l_horizontal := Void
						from i := al_cell.key.count until i < 1 or else not al_cell.key[i].is_digit loop
							i := i - 1
						end
						l_column_letter := al_cell.key.substring (1, i)
						l_column_index := column_index(l_column_letter)
						l_row_index := al_cell.key.substring (i+1, al_cell.key.count).to_integer
						if al_cell.style.is_integer
						and then attached a_book.styles[al_cell.style.to_integer+1] as al_style then
							if attached al_style.indent as al_indent
							and then l_column_letter ~ "A" then
								l_row_indents[l_row_index] := al_indent.to_integer
							end
							if al_style.format_id > 0 then
								l_format := a_book.format(al_style.format_id)
								if attached l_format then
									l_format_id := format_table[l_format]
									if not format_table.has (l_format) then
										l_id := format_insert.witness ([l_format])
										l_format_id := l_id.id
										format_table[l_format] := l_format_id
									end
								end
							end
							if al_style.horizontal ~ "centerContinuous" then
								if attached l_range
								and then l_row_index = l_range.row
								and then l_column_index = l_range.last + 1
								and then (al_cell.value /~ "" implies l_range.value ~ "") then
									l_range.last := l_column_index
									l_range.last_letter := l_column_letter
								else
									l_range := [l_row_index,l_column_index,l_column_index,l_column_letter,l_column_letter,al_cell.value]
									l_ranges.extend(l_range)
								end
								if l_range.value ~ "" then
									l_range.value := al_cell.value
								end
							end
						end
						if attached l_format
						and then l_column_index > 2
						and then l_column_index <= l_first_visible + 20
						and then l_row_index > 6
						and then (al_cell.value.is_double or else al_cell.value ~ "N/A")
						and then is_number_format(l_format) then
							l_rows[l_column_index] := l_rows[l_column_index] + 1
							l_columns[l_row_index] := l_columns[l_row_index] + 1
						end
						if al_cell.formula /~ ""
						or else al_cell.value /~ ""
						or else attached l_horizontal then
							if l_column_index = 1
							and then l_row_index < 6 then
								l_value := al_cell.value.as_lower
								l_value.prune_all (' ')
								l_value.prune_all (':')
								if l_value.starts_with (c_updated) then
									l_updated := l_value.substring(c_updated.count+1,l_value.count)
								elseif al_cell.value.starts_with (c_updated_on) then
									l_updated := l_value.substring(c_updated_on.count+1,l_value.count)
								end
								l_updated.prune_all_trailing (' ')
								if l_period ~ "" then
									l_offset := l_value.substring_index("earning",1)
									if l_offset > 0 then
										l_period := l_value.substring (1, l_offset).as_upper
										if l_period.count > 16 then
											l_period := ""
										end
									end
								end
							end
							from i := 1 until i > al_cell.formula.count loop
								if al_cell.formula[i] = '%N' or else al_cell.formula[i] = '\' then
									l_fix := True
								end
								i := i + 1
							end
							if not l_fix then
								from i := 1 until i > al_cell.value.count loop
									if al_cell.value[i] = '%N' or else al_cell.value[i] = '\' then
										l_fix := True
									end
									i := i + 1
								end
							end
							if l_fix then
								al_cell.formula.prune_all ('\')
								al_cell.formula.replace_substring_all ("%N", "\n")
								al_cell.value.prune_all ('\')
								al_cell.value.replace_substring_all ("%N", "\n")
							end
							l_key := al_cell.key
							if is_mysql then
								--forced to end with \t\n in case cells contain a newline for mysql
								l_key.extend('%T')
							end
							l_output.put_row([l_sheet_id,l_row_index,l_column_index,l_format_id,utf8.encoded_string (al_cell.formula),utf8.encoded_string (al_cell.value),l_column_letter,l_key])
						end
					end
				end
				across l_ranges as ic_ranges loop
					l_range := ic_ranges.item
					a_access.range_command.execute([l_sheet_id,l_range.row,l_range.row,l_range.first,l_range.last,"centerContinuous",utf8.encoded_string (l_range.value)])
				end
				from i := 6 until i > l_columns.count or else l_top > 0 loop
					if l_columns[i] > 20 then
						l_top := i
					end
					i := i + 1
				end
				from i := 3 until i > l_rows.count or else l_left > 0 loop
					if l_rows[i] > 20 then
						l_left := i
					end
					i := i + 1
				end
				l_output.close
				create l_row_file.make (l_rowfile_name,"%T")
				l_row_file.open_write
				create l_indents.make(10)
				create l_parents.make (10)
				across a_sheet.merges as ic_merges loop
					l_merge := ic_merges.item.as_string_8
					l_offset := l_merge.index_of (':', 1)
					l_start := row_column(l_merge.substring (1, l_offset - 1))
					l_end := row_column(l_merge.substring (l_offset + 1, l_merge.count))
					a_access.range_command.execute([l_sheet_id,l_start.row,l_end.row,l_start.column,l_end.column,"mergeCells",""])
				end
				across a_sheet.rows as ic_rows loop
					l_row := ic_rows.item
					i := l_row.rowIndex
					l_indent := l_row_indents[i]
					l_indents[l_indent] := i
					if l_indents[l_indent-1] > 0 then
						l_parents[i] := l_indents[l_indent-1]
					end
					if l_indent > 0
					or else l_row.is_hidden = 1 then
						l_row_file.put_row ([l_sheet_id,i,l_parents[i],l_indent,l_row.is_hidden])
					end
				end
				l_row_file.close
				create l_column_file.make (l_columnfile_name,"%T")
				l_column_file.open_write
				across l_hidden as ic_hidden loop
					l_column_file.put_row ([l_sheet_id,column_letter(ic_hidden.cursor_index),ic_hidden.cursor_index,ic_hidden.item])
				end
				l_column_file.close
				if is_postgres then
					a_access.server.execute("copy factvalue (sheetid,rowIndex,columnIndex,formatId,formula,value,columnLetter,cellKey) from '" + l_factfile_name + "'")
					a_access.server.execute("copy ColumnInfo(sheetid,columnLetter,columnIndex,isHidden) from '" + l_columnfile_name + "'")
					a_access.server.execute("copy RowInfo(sheetid,rowIndex,parent,indent,isHidden) from '" + l_rowfile_name + "'")
	--			else
	--				l_loadfile_name := file_path(<<a_book.xml_path,a_sheet.sheet_name + "_load.sql">>)
	--				create l_load_file.make_open_write (l_loadfile_name)
	--				l_load_file.put_string ("use ConsensusSheetsTest;%N")
	--				l_load_file.put_string (mysql_load_command + "'" + l_factfile_name + "' into table FactValue lines terminated by '\t\n' (firstConsensusId,rowIndex,columnIndex,formatId,formula,`value`,columnLetter,cellKey);%N")
	--				l_load_file.put_string (mysql_load_command + "'" + l_columnfile_name +"' into table ColumnInfo(consensusId,columnLetter,columnIndex,isHidden);%N")
	--				l_load_file.put_string (mysql_load_command + "'" + l_rowfile_name +"' into table RowInfo(consensusId,rowIndex,parent,indent,isHidden);%N")
	--				l_load_file.close
	--				create l_list.make_from_array (<<"--user=" + database_user, "-p" + database_password>>)
	--				l_process := factory.process_launcher (mysql_command, l_list, Void)
	--				l_process.redirect_input_to_file (l_loadfile_name)
	--				l_process.launch
	--				l_process.wait_for_exit
				end
			end
		rescue
			l_failed := True
			retry
		end
	cell_item_name (a_sheet : RL_ENLIS_SHEET;a_record : RL_FACT_VALUE_RECORD) : STRING_32
		local
			l_key,l_year_row : STRING_32
		do
			l_key := "'" + a_sheet.sheetname + "'!A" + a_record.rowindex.out
			if attached cells[l_key] as al_cell then
				Result := al_cell.value.twin
			else
				Result := a_record.global_key
			end
			if a_sheet.year_row > 0 then
				l_year_row := "'" + a_sheet.sheetname + "'!" + a_record.column_letter
				if attached cells[l_year_row + a_sheet.year_row.out] as al_year_cell then
					Result.append (" " + al_year_cell.value)
					if attached cells[l_year_row + (a_sheet.year_row - 1).out] as al_is_actual_cell then
						Result.append ("(" + al_is_actual_cell.value + ")")
					end
				end
			end
		end
	column_letter(a_index : INTEGER) : STRING_8
		local
			i : INTEGER
			l_digits : RL_LIST[INTEGER]
			l_done : BOOLEAN
		do
			create l_digits
			from i := a_index until i = 0 loop
				l_digits.extend ((i-1) \\ 26)
				i := (i-1) // 26
			end
			Result := ""
			from i := l_digits.count until i < 1 loop
				Result.extend((('A').code + l_digits[i]).to_character)
				i := i - 1
			end
		end
--	row_column (a_key : STRING_32) : TUPLE[row,column : INTEGER]
--		local
--			i : INTEGER
--			l_column,l_row : INTEGER
--		do
--			from i := 1 until i > a_key.count or else a_key[i].is_digit loop
--				i := i + 1
--			end
--			if i > 1 then
--				l_column := column_index (a_key.substring (1, i-1))
--			end
--			if a_key.substring (i, a_key.count).is_integer then
--				l_row := a_key.substring (i, a_key.count).to_integer
--			end
--			Result := [l_row,l_column]
--		end
	utf8 : UTF8_ENCODER
		once
			create Result
		end
	records : RL_LIST[RL_CONSENSUS_SHEET_RECORD]
		attribute
			create Result
		end
	formats : HASH_TABLE[STRING_8,INTEGER] attribute create Result.make (100) end
	date_formats : HASH_TABLE[STRING_8,INTEGER] attribute create Result.make(10) end
	read_format (a_format : RL_FORMAT_RECORD)
		do
			formats[a_format.id] := a_format.format
			if a_format.format.substring_index("yy",1) > 0 then
				date_formats[a_format.id] := a_format.format
			end
		end
	make_update_dates
		local
			l_record : RL_FACT_VALUE_RECORD
			l_data : STRING_32
			l_status : INTEGER
			l_file : RAW_FILE
		do
			format_query.apply (agent read_format, Void)
			sheets_query.apply (agent read_sheet,Void)
			across sheets as ic_sheets loop
				fact_value_query.apply (agent read_fact_value, [ic_sheets.item.id])
				across 	ic_sheets.item.records as ic_records loop
					l_record := ic_records.item
					if l_record.is_date then
						excel_dates[l_record.value] := l_record.string_value
					end
				end
			end
			l_data := ""
			across excel_dates as ic_dates loop
				l_data.append (ic_dates.key + "%T" + ic_dates.item + "%N")
			end
			l_status := postgres.execute_copy ("copy excel_dates (excel_date,date_string) from STDIN with delimiter E'\t'", l_data)
		end
	make_read
		local
			l_sheets : RL_LIST[RL_ENLIS_SHEET]
			l_sheet : RL_ENLIS_SHEET
			l_components : RL_LIST[RL_FACT_VALUE_RECORD]
			l_record : RL_FACT_VALUE_RECORD
			l_row : HASH_TABLE[RL_FACT_VALUE_RECORD,INTEGER]
			l_directory : DIRECTORY
			l_timer : RL_PROCESS_TIMER
			l_expression,l_sum : RL_EXPRESSION[RL_EXCEL_DAG,ANY]
			l_graph,l_node_types,l_edge_types,l_node_type,l_edge_type,l_node,l_edge,l_cell,l_sheet_node : RL_JSON_STRUCTURE
			l_edges_json,l_nodes_json,l_cells,l_dags_json,l_cells_row,l_links : RL_JSON_ARRAY
			l_edges,l_nodes : RL_HASH_TABLE[RL_JSON_STRUCTURE,STRING_32]
			l_position : RL_JSON_ARRAY
			l_row_position,l_column_position : RL_JSON_INTEGER
			l_value,l_formula,l_formula_name,l_previous_formula,l_header,l_row_header,l_definitions,l_sheet_name : STRING_32
			l_computed : REAL_64
			i,j,l_offset : INTEGER
			l_file,l_expressions : RAW_FILE
			l_uuid : UUID
			l_date_table : HASH_TABLE[INTEGER,STRING_32]
			l_table,l_formulas,l_features : HASH_TABLE[BOOLEAN,STRING_32]
			l_names : RL_LIST[TUPLE[header,name : STRING_32]]
			l_classes : HASH_TABLE[RL_LIST[STRING_32],STRING_32]
			l_class_features : RL_LIST[STRING_32]
			l_feature : STRING_32
			l_class_texts : HASH_TABLE[STRING_32,STRING_32]
			l_class_text,l_cleaned : STRING_32
		do
			format_query.apply (agent read_format, Void)
			sheets_query.apply (agent read_sheet,Void)
			create l_node_types
			create l_graph
			create l_edge_types
			create l_nodes_json
			create l_edges_json
			l_graph.put (l_node_types, <<"node_types">>)
			l_graph.put (l_edge_types, <<"edge_types">>)
			l_graph.put (l_nodes_json, <<"nodes">>)
			l_graph.put (l_edges_json, <<"links">>)
			create l_node_type.make (<<["name","DAG"]>>)
			create l_dags_json.make_empty
			l_node_type.put (l_dags_json, <<"cells">>)
			l_node_types.put (l_node_type, <<"DAG">>)
			create l_nodes.make (cells.count)
			create l_formulas.make(100)
			create l_class_texts.make (60)
			create l_classes.make (60)
			across sheets as ic_sheets loop
				l_sheet := ic_sheets.item
				l_sheet_name := l_sheet.sheetname
				l_sheet_name.replace_substring_all (" ", "_")
				if attached l_sheet then
					create l_uuid
					create l_node_type.make (<<["name",l_sheet.sheetname]>>)
					create l_sheet_node.make (<<["name",l_sheet.sheetname],
												["id",l_sheet.sheetname],
												["type","sheet"]>>)
					l_nodes_json.extend (l_sheet_node)
					create l_cells.make_empty
					l_node_type.put (l_cells, <<"cells">>)
					l_node_types.put (l_node_type, <<l_sheet.sheetname>>)
					fact_value_query.apply (agent read_fact_value, [ic_sheets.item.id])
					across l_sheet.records as ic_records loop
						l_record := ic_records.item
						if l_record.value ~ "Raw Data Inputs" then
							l_sheet.set_raw_data_row(l_record.rowindex)
						end
						if l_record.columnindex > l_sheet.column_count then
							l_sheet.set_column_count(l_record.columnindex)
						end
						if l_record.rowindex > l_sheet.row_count then
							l_sheet.set_row_count(l_record.rowindex)
						end
						l_row := l_sheet.rows[l_record.rowindex]
						if not attached l_row then
							create l_row.make (l_sheet.column_count)
							l_sheet.rows[l_record.rowindex] := l_row
						end
						l_row[l_record.columnindex] := l_record
					end
					across l_sheet.records as ic_records loop
						l_record := ic_records.item
						if l_sheet.raw_data_row > 0
						and then l_record.rowindex >= l_sheet.raw_data_row then
							l_record.set_is_input
						end
						create l_node.make (<<
										["name",cell_item_name(l_sheet,l_record)],
										["id",l_record.global_key],
										["type",l_record.sheet_name]>>)
						if attached l_sheet.dates[l_record.columnindex] as al_fiscal then
							l_node.put_string (al_fiscal, "Fiscal")
						end
						create l_position.make_empty
						create l_row_position.make (l_record.rowindex)
						create l_column_position.make (l_record.columnindex)
						l_position.extend(l_row_position)
						l_position.extend(l_column_position)
						l_node.put (l_position, <<"position">>)
						l_nodes_json.extend(l_node)
						l_nodes[l_record.global_key] := l_node
						create l_edge.make (<<["source",l_record.global_key],
											 ["target",l_sheet.sheetname],
											 ["type","line_item"]>>)
						l_edges_json.extend (l_edge)
					end
				end
			end
			create l_expressions.make_open_write ("/Users/markhoward/enlis_generated/expressions.txt")
			create l_names
			l_definitions := ""
			create l_classes.make (60)
			across sheets as ic_sheets loop
				l_sheet := ic_sheets.item
				l_sheet.dates.do_nothing
				create l_class_features
				l_classes[l_sheet.class_name] := l_class_features
				create l_formulas.make (60)
				create l_features.make (60)
				l_class_texts[l_sheet.class_name] := l_sheet.class_header
				if attached {RL_JSON_STRUCTURE} l_node_types.item[l_sheet.sheetname] as al_sheet
				and then attached {RL_JSON_ARRAY} al_sheet.item[("cells").as_string_32] as al_cells then
					l_cells := al_cells
					from i := 1 until i > l_sheet.row_count loop
						l_row := l_sheet.rows[i]
						create l_cells_row.make_empty
						l_cells.extend (l_cells_row)
						from j := 1 until j > l_sheet.column_count loop
							l_links := Void
							if attached l_row
							and then attached l_row[j] as al_record then
								if attached l_sheet.dates[al_record.columnindex] as al_header then
									al_record.set_header((al_record.columnindex - l_sheet.minimum_date_index + 1).out)
									if attached al_record.expression as al_expression
									and then attached al_expression.dag as al_dag then
										al_dag.set_column_header(al_header)
										al_dag.redisplay_cell.put(True)
									end
								end
								l_value := al_record.string_value
								l_formula := al_record.formula_display.twin
								l_header := l_sheet.dates[al_record.rowindex]
								if not attached l_header then
									l_header := ""
								end
								if al_record.row_header ~ "Common Shares Outstanding at BS Date" then
									do_nothing
								end
								if al_record.row_header /~ "" then
									l_feature := al_record.row_header + "_" + al_record.rowindex.out
									if not l_features[l_feature] then
										l_class_features.extend (l_feature)
										l_features[l_feature] := True
									end
									if l_formula /~ "" then
										if not l_formulas[l_formula + "_" + al_record.rowindex.out] then
											add_definition(l_definitions,l_sheet.sheetname,l_feature,l_formula,al_record.columnindex)
											l_formulas[l_formula + "_" + al_record.rowindex.out] := True
										end
									end
--									l_formula.replace_substring_all (l_sheet.sheetname + ":", "")
--									l_formula.replace_substring_all ("[" + al_record.columnindex.out + "]", "[]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex-1).out + "]", "[-1]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex-2).out + "]", "[-2]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex+1).out + "]", "[+1]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex+2).out + "]", "[+2]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex+3).out + "]", "[+3]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex+4).out + "]", "[+4]")
--									l_formula.replace_substring_all ("[" + (al_record.columnindex+5).out + "]", "[+5]")
--									l_formula_name := al_record.row_header.twin
--									if not l_formula_name.is_double then
--										l_row_header := al_record.row_header.twin
--										l_formula_name.to_lower
--										l_formula_name.replace_substring_all (" ", "_")
--										l_formula_name.replace_substring_all ("&", "_and_")
--										l_formula_name.replace_substring_all ("/", "_over_")
--										l_formula_name.prune_all ('(')
--										l_formula_name.prune_all (')')
--										l_formula_name.prune_all ('.')
--										l_formula_name.prune_all ('-')
--										l_formula_name.prune_all ('=')
--										l_formula_name.prune_all ('+')
--										l_formula_name.prune_all ('*')
--										l_formula_name.prune_all ('%'')
--										l_formula_name.prune_all_leading ('_')
--										l_row_header.prune_all_leading (' ')
--										l_row_header.prune_all_leading ('=')
--										l_row_header.prune_all_leading ('+')
--										l_row_header.prune_all_leading ('-')
--										l_row_header.prune_all_leading (' ')
--										if not l_formulas[l_row_header] then
--											l_names.extend([l_row_header,l_formula_name])
--										end
--										l_formulas[l_row_header] := True
--									end
								end
								create l_table.make(10)
								if attached al_record.expression as al_expression then
									create l_links.make_empty
									across al_expression.dags as ic_dags loop
										if attached {RL_EXCEL_CELL_KEY} ic_dags.item as al_dag
										and then attached al_dag.record as al_linked_record
										and then not l_table[al_linked_record.global_key] then
											l_table[al_linked_record.global_key] := True
											l_header := al_dag.column_header
											if not attached l_header then
												l_header := ""
											end
											create l_edge.make (<<["sheet",al_linked_record.sheet_name],
																 ["row",al_linked_record.rowindex],
																 ["column",al_linked_record.columnindex],
																 ["line item",al_linked_record.row_header],
																 ["fiscal",l_header],
																 ["formula",al_linked_record.formula_display]>>)
											l_links.extend (l_edge)
										end
									end
								end
								l_header := l_sheet.dates[al_record.rowindex]
							else
								l_value := ""
								l_formula := ""
							end
							if not attached l_header then
								l_header := ""
							end
							create l_cell.make (<<["value",l_value],
												["formula",l_formula],
												["fiscal",l_header]>>)
							if attached l_links then
								l_cell.put (l_links, <<"links">>)
							end
							l_cells_row.extend (l_cell)
							j := j + 1
						end
						i := i + 1
					end
				end
			end
			across cells as ic_cells loop
				l_record := ic_cells.item
				if attached l_record
				and then attached l_record.expression as al_expression then
					if attached al_expression.dag as al_expression_dag then
--						create l_edge.make (<<["source",ic_cells.key],
--											 ["target",al_expression_dag.cellkey],
--											 ["type","computation"]>>)
--						l_edges_json.extend (l_edge)
	--					if attached {RL_EXCEL_SUM} al_expression_dag as al_sum
	--					and then attached al_sum.argument_list as al_items then
	--						l_sum := expression(al_sum)
	--						across al_items as ic_items loop
	--							if attached expression(ic_items.item) as al_item then
	--								al_item.set_parent (l_sum)
	--							end
	--						end
	--					end
--						if l_record.value.is_double
--						and then (l_record.value.to_double - al_expression_dag.computed_value).abs > .00001 then
--							l_computed := al_expression_dag.computed_value
--						end
					end
				end
			end
			across cells as ic_cells loop
				l_record := ic_cells.item
				if attached l_record
				and then attached l_record.expression as al_expression then
					create l_table.make(10)
					across al_expression.dags as ic_dags loop
						if attached {RL_EXCEL_CELL_KEY} ic_dags.item as al_dag
						and then attached al_dag.record as al_record
						and then not l_table[al_record.global_key] then
							l_table[al_record.global_key] := True
							create l_edge.make (<<["source",ic_cells.key],
												 ["target",al_record.global_key],
												 ["type","computation"]>>)
							l_edges_json.extend (l_edge)
						end
					end
--					if attached {RL_EXCEL_FUNCTION} al_expression.dag as al_expression_dag
--					and then attached al_expression_dag.items as al_components then
--						if attached l_nodes[ic_cells.key] as al_node then
--							across al_components as ic_items loop
--								if attached l_nodes[ic_items.item.cell_key] as al_item_node then
--									create l_edge.make (<<["source",ic_cells.key],
--														 ["target",ic_items.item.cell_key],
--														 ["type","computation"]>>)
--									l_edges_json.extend (l_edge)
--								end
--							end
--						end
--	--					if attached {RL_EXCEL_SUM} al_expression_dag as al_sum
--	--					and then attached al_sum.argument_list as al_items then
--	--						l_sum := expression(al_sum)
--	--						across al_items as ic_items loop
--	--							if attached expression(ic_items.item) as al_item then
--	--								al_item.set_parent (l_sum)
--	--							end
--	--						end
--	--					end
--						if l_record.value.is_double
--						and then (l_record.value.to_double - al_expression_dag.computed_value).abs > .00001 then
--							do_nothing
--						end
--					elseif attached {RL_EXCEL_UNARY_OPERATOR} al_expression.dag as al_unary
--					and then attached al_unary.operand as al_operand
--					and then attached l_nodes[al_operand.cell_key] then
--						create l_edge.make (<<["source",ic_cells.key],
--											 ["target",al_operand.cell_key],
--											 ["type","computation"]>>)
--						l_edges_json.extend (l_edge)
--					elseif attached {RL_EXCEL_BINARY_OPERATOR} al_expression.dag as al_binary
--					and then attached al_binary.left as al_left
--					and then attached al_binary.right as al_right
--					and then attached l_nodes[al_left.cell_key]
--					and then attached l_nodes[al_right.cell_key] then
--						create l_edge.make (<<["source",ic_cells.key],
--											 ["target",al_left.cell_key],
--											 ["type","computation"]>>)
--						l_edges_json.extend (l_edge)
--						create l_edge.make (<<["source",ic_cells.key],
--											 ["target",al_right.cell_key],
--											 ["type","computation"]>>)
--						l_edges_json.extend (l_edge)
--					end
				end
			end
--			l_names.sort_by(agent compare_length)
--			across l_names as ic_names loop
--				l_expressions.put_string("Result[%"" + ic_names.item.header + "%"] := %"" + ic_names.item.name + "%"%N")
--			end
			l_definitions := cleaned_expression(l_definitions)
			l_expressions.put_string (l_definitions)
			l_expressions.close
			create l_file.make_open_write ("/Users/markhoward/enlis.json")
			l_file.put_string (l_graph.json_string)
			l_file.close
			generate_classes
		end

	generate_classes
		local
			l_file : RAW_FILE
			l_canonical,l_instance,l_feature,l_sheet,l_input : STRING_32
			l_key,l_previous_key : INTEGER
			l_split : RL_LIST[INTEGER]
		do
--			across l_classes as ic_classes loop
--				l_class_text := l_class_texts[ic_classes.key]
--				if attached l_class_text then
--					across ic_classes.item as ic_features loop
--						l_cleaned := cleaned_expression(ic_features.item)
--						l_class_text.append("%N%T" + l_cleaned + " : HASH_TABLE[REAL_64,INTEGER] attribute create Result.make(10) end")
--					end
--					l_class_text.append ("%Nend%N")
--					create l_file.make_open_write ("/Users/markhoward/enlis_generated/rl_enlis_sheet_" + ic_classes.key.as_lower + ".e")
--					l_file.put_string (l_class_text)
--					l_file.close
--				end
--			end
			across expressions as ic_sheets loop
				l_sheet := ic_sheets.key
				create l_file.make_open_write ("/Users/markhoward/enlis_generated/rl_enlis_" + ic_sheets.key + ".e")
				l_file.put_string ("class " + "%N%TRL_ENLIS_" + l_sheet.as_upper + "%Ninherit%N%TRL_ENLIS_RECORD%Nfeature%N")
				across ic_sheets.item as ic_features loop
					l_canonical := Void
					l_feature := ic_features.key
					create l_split
					l_file.put_string ("%T" + l_feature + "(i : INTEGER) : REAL_64%N%T%Tdo%N")
					across ic_features.item as ic_definitions loop
						l_previous_key := l_key
						l_key := ic_definitions.key
						l_instance := canonical(l_sheet,ic_definitions.item,ic_definitions.key)
						if l_canonical /~ l_instance then
							if l_canonical /= Void then
								l_split.extend(l_previous_key)
							end
							l_canonical := l_instance
						end
					end
					if l_split.count > 0 then
						l_split.extend (l_key)
						across l_split as ic_split loop
							if attached ic_features.item[ic_split.item] as al_version then
								if ic_split.cursor_index = 1 then
									l_file.put_string ("%T%T%Tif period <= " + ic_split.item.out + " then%N")
								elseif ic_split.cursor_index < l_split.count then
									l_file.put_string ("%T%T%Telseif period <= " + ic_split.item.out + " then%N")
								else
									l_file.put_string ("%T%T%Telse%N")
								end
								l_file.put_string ("%T%T%T%TResult := " + canonical(l_sheet,al_version,ic_split.item) + "%N")
							end
						end
						l_file.put_string ("%T%T%Tend%N")
					elseif attached l_canonical then
						l_file.put_string ("%T%T%TResult := " + l_canonical + "%N")
					end
					l_file.put_string ("%T%Tend%N")
				end
				l_file.put_string ("end")
				l_file.close
			end
		end
	canonical(a_sheet,a_expression : STRING_32;a_index : INTEGER) : STRING_32
		local
			j,l_index : INTEGER
			l_indices : RL_LIST[INTEGER]
		do
			Result := a_expression.twin
			create l_indices
			across Result as ic_string loop
				if ic_string.item = '{' then
					l_index := 0
					from j := ic_string.cursor_index + 1 until j > Result.count or else Result[j] = '}' loop
						if Result[j].is_digit then
							l_index := l_index * 10 + Result[j].to_character_8.out.to_integer
						end
						j := j + 1
					end
					l_indices.extend(l_index)
				end
			end
			across l_indices as ic_indices loop
				j := ic_indices.item
				if j < a_index then
					Result.replace_substring_all ("{" + j.out + "}", "(i-" + (a_index - j).out + ")")
				elseif j = a_index then
					Result.replace_substring_all ("{" + j.out + "}", "(i)")
				elseif j > a_index then
					Result.replace_substring_all ("{" + j.out + "}", "(i+" + (j-a_index).out + ")")
				end
				j := j + 1
			end
			Result.replace_substring_all ("{", "(")
			Result.replace_substring_all ("}", ")")
			Result.replace_substring_all (a_sheet + ".", "")
		end
	add_definition(a_definitions,a_sheet_name,a_feature,a_definition : STRING_32;a_column : INTEGER)
		local
			l_definition,l_feature,l_sheet_name : STRING_32
			l_definitions : HASH_TABLE[STRING_32,INTEGER]
			l_features : HASH_TABLE[HASH_TABLE[STRING_32,INTEGER],STRING_32]
			i : INTEGER
		do
			l_feature := a_feature.twin
			if not l_feature[1].is_alpha then
				from i := 1 until i > l_feature.count or else l_feature[i].is_alpha loop
					i := i + 1
				end
				if i <= l_feature.count then
					l_feature := l_feature.substring (i, l_feature.count)
				end
			end
			l_definition := a_sheet_name + "." + l_feature + "(" + a_column.out + " : INTEGER)==" + a_definition + "%N"
			a_definitions.append (l_definition)
			l_sheet_name := cleaned_expression(a_sheet_name)
			l_feature := cleaned_expression(l_feature)
			l_definition := cleaned_expression(a_definition)
			l_features := expressions[l_sheet_name]
			if not attached l_features then
				create l_features.make (100)
				expressions[l_sheet_name] := l_features
			end
			l_definitions := l_features[l_feature]
			if not attached l_definitions then
				create l_definitions.make (10)
				l_features[l_feature] := l_definitions
			end
			l_definitions[a_column] := l_definition
		end
	excel_dates : HASH_TABLE[STRING_32,STRING_32] attribute create Result.make(500) end
	expressions : HASH_TABLE[HASH_TABLE[HASH_TABLE[STRING_32,INTEGER],STRING_32],STRING_32]
		once
			create Result.make(20)
		end
	cleaned_expression(a_string : STRING_32) : STRING_32
		do
			Result := a_string.twin
			across expression_name_table as ic_names loop
				Result.replace_substring_all(ic_names.key,ic_names.item)
			end
			Result.replace_substring_all (" ", "_")
			Result.replace_substring_all (":", ".")
			Result.replace_substring_all ("==", " := ")
			Result.to_lower
		end
	compare_length (a_1,a_2 : TUPLE[header,name : STRING_32]) : BOOLEAN
		do
			Result:= a_2.header.count < a_1.header.count
		end
	record (a_sheet : RL_ENLIS_SHEET;a_row,a_column : INTEGER) : detachable RL_FACT_VALUE_RECORD
		local
			l_key : STRING_32
		do
			l_key := "'" + a_sheet.sheetname + "'!" + column_letter (a_column) + a_row.out
			Result := cells[l_key]
		end
--	expressions : HASH_TABLE[RL_EXPRESSION[RL_EXCEL_DAG,ANY],STRING_32] attribute create Result.make(2000) end
--	expression (a_dag : RL_EXCEL_DAG) :  RL_EXPRESSION[RL_EXCEL_DAG,ANY]
--		local
--			l_expression : RL_EXPRESSION[RL_EXCEL_DAG,ANY]
--		do
--			if attached a_dag.formula.row_header (a_dag.sheet_name,a_dag.row) as al_header then
--				l_expression := expressions[al_header.value]
--				if not attached l_expression then
--					create {RL_DOUBLE_EXPRESSION[RL_EXCEL_DAG]} l_expression.make (al_header.value,agent dag_value)
--					expressions[al_header.value] := l_expression
--				end
--				Result := l_expression
--			else
--				create {RL_UNKNOWN_EXPRESSION[RL_EXCEL_DAG]} Result
--			end
--		end
	dag_value(a_dag : RL_EXCEL_DAG) : DOUBLE
		do
			Result := a_dag.computed_value
		end
	read_fact_value(a_record : RL_FACT_VALUE_RECORD)
		local
			l_expression : RL_EXCEL_FORMULA
			l_key : STRING_32
			l_sheet : RL_ENLIS_SHEET
		do
--			across sheets as ic_sheets until a_record.formula.index_of ('!', 1) = 0 loop
--				a_record.formula.replace_substring_all (ic_sheets.item.sheetname, ic_sheets.item.filechecksum)
--			end
			l_sheet := sheets[a_record.sheetid]
			if attached l_sheet as al_sheet then
				a_record.set_sheet_name(l_sheet.sheetname)
				l_key := a_record.global_key
				cells[l_key] := a_record
				a_record.set_cells (cells)
				if a_record.formula /~ "" then
					create l_expression.make (cells,l_sheet.sheetname,l_sheet.is_date1904,a_record.cellkey,a_record.formula)
					a_record.set_expression(l_expression)
				end
				if attached date_formats[a_record.formatid] as al_format then
					if l_sheet.is_date1904 then
						a_record.set_is_date1904
					end
					a_record.set_is_date
					a_record.set_format (al_format)
				end
				if a_record.columnindex = 1
				and then a_record.value.starts_with ("Fiscal Year End")
				and then (l_sheet.year_row = 0 or else a_record.rowindex < l_sheet.year_row) then
					l_sheet.set_year_row(a_record.rowindex)
				end
				l_sheet.records[a_record.cellkey] := a_record
			end
		end
	read_sheet(a_sheet : RL_ENLIS_SHEET)
		do
			sheets[a_sheet.id] := a_sheet
		end
	sheets : HASH_TABLE[RL_ENLIS_SHEET,INTEGER] attribute create Result.make(100) end
	cells : HASH_TABLE[RL_FACT_VALUE_RECORD,STRING_32]
		attribute
			create Result.make(100_000)
		end
 	number_formats : HASH_TABLE[BOOLEAN,STRING_32]
 		once
 			create Result.make(20)
			Result["#,##0.0_);\(#,##0.0\)"] := True
			Result["0%%"] := True
			Result["#,##0_);(#,##0)"] := True
			Result["%"$%"#,##0.00_);\(%"$%"#,##0.00\)"] := True
			Result["%"$%"#,##0_);\(%"$%"#,##0\)"] := True
			Result["#,##0.0%%_);\(#,##0.0%%\)"] := True
			Result["#,##0%"bp%"_);\(#,##0%"bp%"\)"] := True
			Result["#,##0%"bps%"_);\(#,##0%"bps%"\)"] := True
			Result["0%"bps%""] := True
			Result["_(* #,##0.00_);_(* \(#,##0.00\);_(* %"-%"??_);_(@_)"] := True
			Result["#,##0_);[Red](#,##0)"] := True
			Result["#,##0"] := True
			Result["0.00_);\(0.00\)"] := True
			Result["_(* #,##0_);_(* \(#,##0\);_(* %"-%"_);_(@_)"] := True
			Result["0.0%%"] := True
			Result["%"$%"#,##0.0_);\(%"$%"#,##0.0\)"] := True
			Result["%"$%"#,##0.00"] := True
			Result["#,##0 ;(#,##0"] := True
			Result["%"$%"#,##0"] := True
			Result["%"$%"#,##0.0"] := True
			Result["%"$%"#,##0.00"] := True
			Result["%"$%"#,##0.00_);\(%"$%"#,##0.00\)"] := True
			Result["%"$%"#,##0.0_);\(%"$%"#,##0.0\)"] := True
			Result["%"$%"#,##0;[Red]%"$%"#,##0"] := True
			Result["%"$%"#,##0;\-%"$%"#,##0"] := True
			Result["%"$%"#,##0_);\(%"$%"#,##0\)"] := True
			Result["#,##0"] := True
			Result["#,##0 ;(#,##0"] := True
			Result["#,##0 ;[Red](#,##0)"] := True
			Result["#,##0%"bp%"_);\(#,##0%"bp%"\)"] := True
			Result["#,##0%"bps%"_);\(#,##0%"bps%"\)"] := True
			Result["#,##0%%_);\(#,##0%%\)"] := True
			Result["#,##0.0%%_);\(#,##0.0%%\)"] := True
			Result["#,##0.00%%_);\(#,##0.00%%\)"] := True
			Result["#,##0.000_);\(#,##0.000\)"] := True
			Result["#,##0.00;(#,##0.00)"] := True
			Result["#,##0.0_);\(#,##0.0\)"] := True
			Result["#,##0_ ;\-#,##0\ "] := True
			Result["0"] := True
			Result["0%%"] := True
			Result["0.0%%"] := True
			Result["0.00"] := True
			Result["0.00%%"] := True
			Result["0.0_);\(0.0\)"] := True
			Result["0_);\(0\)"] := True
			Result["[$$-409]#,##0.00_ ;\-[$$-409]#,##0.00\ "] := True
			Result["[$$-409]#,##0.00_);\([$$-409]#,##0.00\)"] := True
			Result["[$$-409]#,##0.0_);\([$$-409]#,##0.0\)"] := True
			Result["[$$-409]#,##0_ ;\-[$$-409]#,##0\ "] := True
			Result["[$$-409]#,##0_);\([$$-409]#,##0\)"] := True
			Result["\$#,##0_);%"($%"#,##0\)"] := True
			Result["_(* #,##0.00_);_(* \(#,##0.00\);_(* %"-%"??_);_(@_)"] := True
			Result["_(* #,##0.0_);_(* \(#,##0.0\);_(* %"-%"??_);_(@_)"] := True
			Result[""] := True
		end

	currency (a_value : STRING_32) : detachable STRING_32
		local
			l_delimited : RL_DELIMITED_TEXT_32
			l_value : STRING_32
			l_start,l_end : INTEGER
		do
			l_value := a_value.as_upper
			l_end := l_value.substring_index ("EXCEPT", 1) - 1
			if l_value[1] = '(' or else l_value[1] = '%N' then
				l_start := 2
			else
				l_start := 1
			end
			if l_end >= l_start then
				from until l_end < l_start or else (l_value[l_end] /= ',' and l_value[l_end] /= ' ') loop
					l_end := l_end - 1
				end
				if l_end >= l_start then
					Result := l_value.substring (l_start, l_end)
				end
			end
		end


 	is_number_format(a_format :  STRING_32) : BOOLEAN
 		do
 			Result := number_formats[a_format]
 			or else a_format.substring_index ("#,##0", 1) > 0
   		end
    spreadsheets : HASH_TABLE[BOOLEAN,STRING_8]
		once
			create Result.make(1000)
		end

	python_path : STRING_8
		local
			l_path : FILE_NAME
			l_directory : DIRECTORY
		attribute
			create l_path.make_temporary_name
			create l_directory.make (l_path.string)
			l_directory.create_dir
			Result := l_path.string + "/excel_to_csv.py"
		end

	consensus_sheet_selection : STRING_8 =
		"[
		select * from sheets
		]"

	read_consensus_sheet_record (a_record : RL_CONSENSUS_SHEET_RECORD)
		do
			if attached a_record.ticker as al_ticker then
				if spreadsheets.has(a_record.filename) then
					consensus_sheets_by_ticker[al_ticker] := a_record
				end
			end
			consensus_sheet_records[a_record.id] := a_record
		end

	consensus_sheet_records : HASH_TABLE[RL_CONSENSUS_SHEET_RECORD,INTEGER]
		attribute
			create Result.make(1000)
		end
	consensus_sheets_by_ticker : HASH_TABLE[RL_CONSENSUS_SHEET_RECORD,STRING_8]
		attribute
			create Result.make(1000)
		end
	c_sheetname : STRING_8 = "sheetname:"
	c_hidden_rows : STRING_8 = "hidden_rows:"
	c_hidden_columns : STRING_8 = "hidden_columns:"
	c_indents : STRING_8 = "indents:"
	c_updated_on : STRING_32 = "updatedon"
	c_updated : STRING_32 = "updated"
	convert_excel_to_csv(a_record : RL_CONSENSUS_SHEET_RECORD)
		local
			l_directory : DIRECTORY
			l_path : PATH
			l_factory : BASE_PROCESS_FACTORY
			l_process : BASE_PROCESS
			l_list : ARRAYED_LIST[STRING_8]
		do
			create l_factory
			create l_list.make_from_array (<<python_path,file_path(<<source_directory,a_record.filename>>),out_directory>>)
			l_process := l_factory.process_launcher ("/usr/local/bin/python3", l_list, Void)
			l_process.launch
			l_process.wait_for_exit
		end
--	flat (a_ticker : STRING_8) : STRING_32
--		local
--			l_rows : HASH_TABLE[RL_ROW_RECORD,INTEGER]
--			l_row_headers : RL_LIST[detachable TUPLE[parent,header : STRING_32]]
--			l_column_headers : RL_LIST[detachable RL_CONSENSUS_HEADER]
--			l_bounds : TUPLE[rows,columns : INTEGER]
--			l_header : RL_CONSENSUS_HEADER
--			i,j,l_indent,l_offset,l_start,l_analyst_row,l_date_row : INTEGER
--			l_sheet : RL_CONSENSUS_SHEET_RECORD
--			l_fact : RL_FACT_VALUE_RECORD
--			l_parent,l_value,l_year,l_type : STRING_32
--			l_quarter : CHARACTER_32
--			l_ranges : RL_LIST[RL_LIST[RL_EXCEL_RANGE_RECORD]]
--		do
--			create l_rows.make (1000)
--			l_bounds := [0,0]
--			l_sheet := consensus_sheets_by_ticker[a_ticker]
--			Result := ""
--			if attached l_sheet then
--				create l_ranges
--				row_query.apply (agent read_row(?,l_rows), [l_sheet.id])
--				fact_value_query.apply (agent read_fact_value(?,l_rows,l_bounds), [l_sheet.id])
--				range_query.apply(agent read_range(?,l_ranges),[l_sheet.id])
--				create l_row_headers
--				create l_column_headers
--				l_parent := ""
--				from j := 1 until j > l_bounds.columns loop
--					create l_header
--					l_column_headers.force (Void, j)
--					l_column_headers.force (l_header, j)
--					j := j + 1
--				end
--				from i := 1 until i >= l_sheet.minfactrow loop
--					if attached l_rows[i] as al_row
--					and then attached al_row.columns[1] as al_fact then
--						l_value := al_fact.value.as_lower
--						l_value.prune_all (' ')
--						l_value.prune_all ('/')
--						if l_value.substring_index("analystname",1) > 0 then
--							l_analyst_row := i
--						end
--						if l_value.substring_index("fy",1) > 0 then
--							l_date_row := i
--						end
--					end
--					i := i + 1
--				end
--				if l_analyst_row = 0 then
--					print("no analyst name for " + a_ticker + "%N")
--				end
--				from j := 1 until j > l_bounds.columns loop
--					l_header := l_column_headers[j]
--					if not attached l_header then
--						create l_header
--						l_column_headers.force (Void, j)
--						l_column_headers.force (l_header, j)
--					end
--					from i := 1 until i >= l_sheet.minfactrow loop
--						if attached l_rows[i] as al_row
--						and then attached al_row.columns[j] as al_fact then
--							l_value := al_fact.value
--							l_offset := l_value.index_of('Q',1)
--							if l_offset > 1
--							and then l_value[l_offset-1].is_digit
--							and then (l_offset = 2 or else l_value[l_offset-2] = ' ') then
--								l_quarter := l_value[l_offset-1]
--							end
--							if l_value[1].is_digit then
--								if l_value[2] = 'Q' then
--									l_start := 3
--									l_header.set_quarter(l_value.substring (1, 1))
--								else
--									l_start := 1
--								end
--								l_offset := l_value.index_of (' ', l_start)
--								if l_offset > 0 then
--									l_year := l_value.substring (l_start, l_offset - 1)
--									l_type := l_value.substring (l_offset + 1, l_value.count)
--								else
--									l_year := l_value.substring (l_start, l_value.count)
--									l_type := Void
--								end
--								if i = l_date_row
--								and then l_year.is_integer then
--									l_header.set_year (l_year)
--								end
--								l_header.set_type (l_type)
--							end
--							if i = l_analyst_row
--							and then l_value /~ "" then
--								l_header.set_analyst (l_value)
--							end
--						end
--						i := i + 1
--					end
--					j := j + 1
--				end
--				from i := 1 until i > l_bounds.rows loop
--					if attached l_rows[i] as al_row then
--						l_fact := al_row.columns[1]
--						if attached l_fact then
--							if al_row.indent = 0 then
--								l_parent := l_fact.value
--							end
--							l_row_headers.force (Void, i)
--							l_row_headers[i] := [l_parent,l_fact.value]
--							Result.append (l_parent + "%T" + l_fact.value + "%N")
--						end
--					end
--					i := i + 1
--				end
--			end
--		end
	read_range(a_range : RL_EXCEL_RANGE_RECORD;a_ranges : RL_LIST[RL_LIST[RL_EXCEL_RANGE_RECORD]])
		local
			l_ranges : RL_LIST[RL_EXCEL_RANGE_RECORD]
		do
			l_ranges := a_ranges[a_range.firstrow]
			if not attached l_ranges then
				create l_ranges
				a_ranges[a_range.firstrow] := l_ranges
			end
			l_ranges.extend (a_range)
		end
--	column_index (a_key : STRING_8) : INTEGER
--		local
--			i,j : INTEGER
--		do
--			j := 1
--			from i := a_key.count until i < 1 loop
--				Result := Result + (a_key[i].code - ('A').code + 1) * j
--				j := j * 26
--				i := i - 1
--			end
--		end
	read_row(a_record : RL_ROW_RECORD;a_rows : HASH_TABLE[RL_ROW_RECORD,INTEGER])
		do
			a_rows[a_record.rowindex] := a_record
		end
--	read_fact_value(a_record : RL_FACT_VALUE_RECORD;a_rows : HASH_TABLE[RL_ROW_RECORD,INTEGER];a_bounds : TUPLE[rows,columns : INTEGER])
--		local
--			l_row : RL_ROW_RECORD
--		do
--			if attached a_rows[a_record.rowindex] as al_row then
--				l_row := al_row
--			else
--				create l_row
--				a_rows[a_record.rowindex] := l_row
--			end
--			l_row.columns[a_record.columnindex] := a_record
--			if a_bounds.rows < a_record.rowindex then
--				a_bounds.rows := a_record.rowindex
--			end
--			if a_bounds.columns < a_record.columnindex then
--				a_bounds.columns := a_record.columnindex
--			end
--			if attached consensus_sheet_records[a_record.firstconsensusid] as al_sheet then
--				if a_record.rowindex < al_sheet.minfactrow
--				or else a_record.columnindex < al_sheet.minfactcolumn then
--					do_nothing
--				end
--			end
--		end
	expression_name_table : HASH_TABLE [STRING_32,STRING_32]
		once
			create Result.make(300)
			Result["After Tax Weighted Average Cost of Capital"] := "after_tax_weighted_average_cost_of_capital"
			Result["Present Value of Preferred Residual Income"] := "present_value_of_preferred_residual_income"
			Result["Present Value of FCF to Minority Interest"] := "present_value_of_fcf_to_minority_interest"
			Result["Beginning Book Value of Minority Interest"] := "beginning_book_value_of_minority_interest"
			Result["Present Value of Residual Investor Income"] := "present_value_of_residual_investor_income"
			Result["Present Value of Residual Interest Income"] := "present_value_of_residual_interest_income"
			Result["Net Interest Expense to Net Debtholders"] := "net_interest_expense_to_net_debtholders"
			Result["Beginning Book Value of Preferred Stock"] := "beginning_book_value_of_preferred_stock"
			Result["Present Value of FCF to Preferred Stock"] := "present_value_of_fcf_to_preferred_stock"
			Result["Less Value of Contingent Equity Claims"] := "less_value_of_contingent_equity_claims"
			Result["Forecast Equity Value Before Time Adj."] := "forecast_equity_value_before_time_adj"
			Result["Forecasted Value as of Valuation Date"] := "forecasted_value_as_of_valuation_date"
			Result["Forecast Five Year Growth Rate in EPS"] := "forecast_five_year_growth_rate_in_eps"
			Result["Residual Income to Minority Interest"] := "residual_income_to_minority_interest"
			Result["Total Calculated Product Revenue (M)"] := "total_calculated_product_revenue_m"
			Result["Common Shares Outstanding at BS Date"] := "common_shares_outstanding_at_bs_date"
			Result["Dividends Paid to Minority Interest"] := "dividends_paid_to_minority_interest"
			Result["Dividends to Preferred Stockholders"] := "dividends_to_preferred_stockholders"
			Result["Increase in Other Curr. Liabilities"] := "increase_in_other_curr_liabilities"
			Result["Equivalent Shares at Valuation Date"] := "equivalent_shares_at_valuation_date"
			Result["Value Attributable to Common Equity"] := "value_attributable_to_common_equity"
			Result["Free Cash Flow to Minority Interest"] := "free_cash_flow_to_minority_interest"
			Result["Average Implied Default Probability"] := "average_implied_default_probability"
			Result["Return on Equity (b4 non-recurring)"] := "return_on_equity_b4_nonrecurring"
			Result["Present Value of MI Residual Income"] := "present_value_of_mi_residual_income"
			Result["Net Operating Margin (b4 non-rec.)"] := "net_operating_margin_b4_nonrec"
			Result["Common Equity at Beginning of Year"] := "common_equity_at_beginning_of_year"
			Result["Minority Interest/After Tax Income"] := "minority_interest_over_after_tax_income"
			Result["Net Interest Expense/Avge Net Debt"] := "net_interest_expense_over_avge_net_debt"
			Result["Residual Income to Preferred Stock"] := "residual_income_to_preferred_stock"
			Result["Forecasted Price at Valuation Date"] := "forecasted_price_at_valuation_date"
			Result["Common Equity Issued (Repurchased)"] := "common_equity_issued_repurchased"
			Result["Present Value of FCF to Investors"] := "present_value_of_fcf_to_investors"
			Result["Ending Other Current Assets/Sales"] := "ending_other_current_assets_over_sales"
			Result["Free Cash Flow to Preferred Stock"] := "free_cash_flow_to_preferred_stock"
			Result["Total Liabilities to Total Assets"] := "total_liabilities_to_total_assets"
			Result["Shares Outstanding at End of Year"] := "shares_outstanding_at_end_of_year"
			Result["Pref. Dividends/Avge Pref. Stock"] := "pref_dividends_over_avge_pref_stock"
			Result["Present Value of Residual Income"] := "present_value_of_residual_income"
			Result["Increase in Other Current Assets"] := "increase_in_other_current_assets"
			Result["Avge Days to Collect Receivables"] := "avge_days_to_collect_receivables"
			Result["Net Income (available to common)"] := "net_income_available_to_common"
			Result["Residual Income to all Investors"] := "residual_income_to_all_investors"
			Result["Increase in Net Operating Assets"] := "increase_in_net_operating_assets"
			Result["Ending Other Current Liabs/Sales"] := "ending_other_current_liabs_over_sales"
			Result["Net Issuance of Preferred Stock"] := "net_issuance_of_preferred_stock"
			Result["Free Cash Flow to Common Equity"] := "free_cash_flow_to_common_equity"
			Result["Dep&Amort/Avge PP&E and Intang."] := "dep_and_amort_over_avge_pp_and_e_and_intang"
			Result["Operating Cash and Market. Sec."] := "operating_cash_and_market_sec"
			Result["New Shares Issued (Repurchased)"] := "new_shares_issued_repurchased"
			Result["Less Value of Minority Interest"] := "less_value_of_minority_interest"
			Result["Present Value of First 10 Years"] := "present_value_of_first_10_years"
			Result["Beginning Net Operating Assets"] := "beginning_net_operating_assets"
			Result["Return on Net Operating Assets"] := "return_on_net_operating_assets"
			Result["Estimated Price/Earnings Ratio"] := "estimated_price_over_earnings_ratio"
			Result["Minority Interest/Total Assets"] := "minority_interest_over_total_assets"
			Result["/-Net Issuance of Common Stock"] := "over_net_issuance_of_common_stock"
			Result["Sales Growth (last five years)"] := "sales_growth_last_five_years"
			Result["x Net Operating Asset Turnover"] := "x_net_operating_asset_turnover"
			Result["Avge Inventory Holding Period"] := "avge_inventory_holding_period"
			Result["/-Clean Surplus Plug (Ignore)"] := "over_clean_surplus_plug_ignore"
			Result["Minority Interest in Earnings"] := "minority_interest_in_earnings"
			Result["Ext. Items & Disc. Ops./Sales"] := "ext_items__and__disc_ops_over_sales"
			Result["Present Value Beyond 10 Years"] := "present_value_beyond_10_years"
			Result["Less Value of Preferred Stock"] := "less_value_of_preferred_stock"
			Result["Average ROE (last five years)"] := "average_roe_last_five_years"
			Result["Increase in Other Liabilities"] := "increase_in_other_liabilities"
			Result["Increase in Accounts Payable"] := "increase_in_accounts_payable"
			Result["Paid in Common Capital (Net)"] := "paid_in_common_capital_net"
			Result["Dividends on Preferred Stock"] := "dividends_on_preferred_stock"
			Result["Non-Current Op. Accruals/NOA"] := "noncurrent_op_accruals_over_noa"
			Result["Total Liabilities and Equity"] := "total_liabilities_and_equity"
			Result["Net Issuance of Common Stock"] := "net_issuance_of_common_stock"
			Result["Preferred Stock/Total Assets"] := "preferred_stock_over_total_assets"
			Result["Most Recent Fiscal Year End:"] := "most_recent_fiscal_year_end:"
			Result["Pecentage Service to Product"] := "pecentage_service_to_product"
			Result["Fiscal Year End (YYYY-MM-DD)"] := "fiscal_year_end_yyyymmdd"
			Result["Terminal Year's Sales Growth"] := "terminal_years_sales_growth"
			Result["Forecasted Price at Year End"] := "forecasted_price_at_year_end"
			Result["Net Income Before Ext. Items"] := "net_income_before_ext_items"
			Result["Beginning Book Value of Debt"] := "beginning_book_value_of_debt"
			Result["Free Cash Flows to Investors"] := "free_cash_flows_to_investors"
			Result["Present Value of FCF to Debt"] := "present_value_of_fcf_to_debt"
			Result["Ending Accounts Payable/COGS"] := "ending_accounts_payable_over_cogs"
			Result["Net Working Capital Turnover"] := "net_working_capital_turnover"
			Result["Net Operating Asset Turnover"] := "net_operating_asset_turnover"
			Result["Depreciation & Amortization"] := "depreciation__and__amortization"
			Result["Increase in Working Capital"] := "increase_in_working_capital"
			Result["implied default probability"] := "implied_default_probability"
			Result["Increase in Preferred Stock"] := "increase_in_preferred_stock"
			Result["Most Recent Fiscal Year End"] := "most_recent_fiscal_year_end"
			Result["Dividends Paid on Preferred"] := "dividends_paid_on_preferred"
			Result["Free Cash Flow to Investors"] := "free_cash_flow_to_investors"
			Result["Ending Operating Cash/Sales"] := "ending_operating_cash_over_sales"
			Result["Non-Operating Income (Loss)"] := "nonoperating_income_loss"
			Result["Estimated Market/Book Ratio"] := "estimated_market_over_book_ratio"
			Result["Long-Term Debt/Total Assets"] := "longterm_debt_over_total_assets"
			Result["Ending Taxes Payable/Sales"] := "ending_taxes_payable_over_sales"
			Result["Forecast 5 Year EPS Growth"] := "forecast_5_year_eps_growth"
			Result["Non-Operating Income/Sales"] := "nonoperating_income_over_sales"
			Result["Increase in Deferred Taxes"] := "increase_in_deferred_taxes"
			Result["Increase in Operating Cash"] := "increase_in_operating_cash"
			Result["Value of Minority Interest"] := "value_of_minority_interest"
			Result["Net Income to Total Assets"] := "net_income_to_total_assets"
			Result["Total Current Liabilities"] := "total_current_liabilities"
			Result["Percenteage Other to Calc"] := "percenteage_other_to_calc"
			Result["Cost of Minority Interest"] := "cost_of_minority_interest"
			Result["Current Debt/Total Assets"] := "current_debt_over_total_assets"
			Result["Increase in Common Equity"] := "increase_in_common_equity"
			Result["Dividends on Common Stock"] := "dividends_on_common_stock"
			Result["Avge Days to Pay Payables"] := "avge_days_to_pay_payables"
			Result["Ending Other Assets/Sales"] := "ending_other_assets_over_sales"
			Result["Residual Interest Expense"] := "residual_interest_expense"
			Result["Other Current Liabilities"] := "other_current_liabilities"
			Result["Net Financial Obligations"] := "net_financial_obligations"
			Result["Common Shares Outstanding"] := "common_shares_outstanding"
			Result["Increase in Taxes Payable"] := "increase_in_taxes_payable"
			Result["Implied Return on Equity"] := "implied_return_on_equity"
			Result["Inventory Holding Period"] := "inventory_holding_period"
			Result["Cost of Goods Sold/Sales"] := "cost_of_goods_sold_over_sales"
			Result["This Year's Sales Growth"] := "this_years_sales_growth"
			Result["EBIT to Interest Expense"] := "ebit_to_interest_expense"
			Result["Current Op. Accruals/NOA"] := "current_op_accruals_over_noa"
			Result["Ending Intangibles/Sales"] := "ending_intangibles_over_sales"
			Result["Value of Preferred Stock"] := "value_of_preferred_stock"
			Result["EBITDA Interest Coverage"] := "ebitda_interest_coverage"
			Result["This Year's Forecast EPS"] := "this_years_forecast_eps"
			Result["Ending Receivables/Sales"] := "ending_receivables_over_sales"
			Result["Financial Leverage (LEV)"] := "financial_leverage_lev"
			Result["Purchases of Intangibles"] := "purchases_of_intangibles"
			Result["Increase in Other Assets"] := "increase_in_other_assets"
			Result["Net Borrowing Cost (NBC)"] := "net_borrowing_cost_nbc"
			Result["Dividends Paid on Common"] := "dividends_paid_on_common"
			Result["Ending Investments/Sales"] := "ending_investments_over_sales"
			Result["Sustainable Growth Rate"] := "sustainable_growth_rate"
			Result["Ext. Items & Disc. Ops."] := "ext_items__and__disc_ops"
			Result["Ending Inventories/COGS"] := "ending_inventories_over_cogs"
			Result["Increase in Investments"] := "increase_in_investments"
			Result["Increase in Receivables"] := "increase_in_receivables"
			Result["Increase in Pref. Stock"] := "increase_in_pref_stock"
			Result["ROE = RNOA + LEV*Spread"] := "roe__rnoa__levspread"
			Result["Other Liabilities/Sales"] := "other_liabilities_over_sales"
			Result["Fiscal Year of Forecast"] := "fiscal_year_of_forecast"
			Result["Company Name and Ticker"] := "company_name_and_ticker"
			Result["Cost of Preferred Stock"] := "cost_of_preferred_stock"
			Result["x Total Asset Turnover"] := "x_total_asset_turnover"
			Result["Free Cash Flow to Debt"] := "free_cash_flow_to_debt"
			Result["Tax Shield on Interest"] := "tax_shield_on_interest"
			Result["Beginning Cash Balance"] := "beginning_cash_balance"
			Result["End. Retained Earnings"] := "end_retained_earnings"
			Result["Less Value of Net Debt"] := "less_value_of_net_debt"
			Result["Beg. Retained Earnings"] := "beg_retained_earnings"
			Result["Cost of Equity Capital"] := "cost_of_equity_capital"
			Result["EBIT Interest Coverage"] := "ebit_interest_coverage"
			Result["Operating Accruals/NOA"] := "operating_accruals_over_noa"
			Result["Estimated Price/Share"] := "estimated_price_over_share"
			Result["Teriminal Growth Rate"] := "teriminal_growth_rate"
			Result["Dividend Payout Ratio"] := "dividend_payout_ratio"
			Result["Ending Net PP&E/Sales"] := "ending_net_pp_and_e_over_sales"
			Result["Funds From Operations"] := "funds_from_operations"
			Result["Cost of Common Equity"] := "cost_of_common_equity"
			Result["Increase in Inventory"] := "increase_in_inventory"
			Result["Net Financial Expense"] := "net_financial_expense"
			Result["Number of Units Sold"] := "number_of_units_sold"
			Result["Subtotal Revenue (M)"] := "subtotal_revenue_m"
			Result["Net Operating Margin"] := "net_operating_margin"
			Result["Debt to Equity Ratio"] := "debt_to_equity_ratio"
			Result["Forecast Price/Share"] := "forecast_price_over_share"
			Result["Income Taxes Payable"] := "income_taxes_payable"
			Result["Deferred Taxes/Sales"] := "deferred_taxes_over_sales"
			Result["Total Current Assets"] := "total_current_assets"
			Result["Net Operating Assets"] := "net_operating_assets"
			Result["Capital Expenditures"] := "capital_expenditures"
			Result["Cash From Operations"] := "cash_from_operations"
			Result["Terminal Growth Rate"] := "terminal_growth_rate"
			Result["Fiscal Year End Date"] := "fiscal_year_end_date"
			Result["Net Issuance of Debt"] := "net_issuance_of_debt"
			Result["Present Value of FCF"] := "present_value_of_fcf"
			Result["Net Interest Expense"] := "net_interest_expense"
			Result["Other Current Assets"] := "other_current_assets"
			Result["Net Operating Income"] := "net_operating_income"
			Result["Cash From Investing"] := "cash_from_investing"
			Result["Cash From Financing"] := "cash_from_financing"
			Result["Terminal Year's ROE"] := "terminal_years_roe"
			Result["Service Revenue (M)"] := "service_revenue_m"
			Result["Cash from Investing"] := "cash_from_investing"
			Result["Ending Cash Balance"] := "ending_cash_balance"
			Result["Annual Sales Growth"] := "annual_sales_growth"
			Result["Total Common Equity"] := "total_common_equity"
			Result["Preferred Dividends"] := "preferred_dividends"
			Result["Spread (RNOA - NBC)"] := "spread_rnoa__nbc"
			Result["NOA Turnover Growth"] := "noa_turnover_growth"
			Result["Other Income (Loss)"] := "other_income_loss"
			Result["Cost of Goods Sold"] := "cost_of_goods_sold"
			Result["Less Value of Debt"] := "less_value_of_debt"
			Result["Net Change in Cash"] := "net_change_in_cash"
			Result["Other Income/Sales"] := "other_income_over_sales"
			Result["Effective Tax Rate"] := "effective_tax_rate"
			Result["CFO to Total Debt"] := "cfo_to_total_debt"
			Result["Total Liabilities"] := "total_liabilities"
			Result["Retained Earnings"] := "retained_earnings"
			Result["Net Profit Margin"] := "net_profit_margin"
			Result["Minority Interest"] := "minority_interest"
			Result["FFO to Total Debt"] := "ffo_to_total_debt"
			Result["Total Revenue (M)"] := "total_revenue_m"
			Result["Other Liabilities"] := "other_liabilities"
			Result["Date of Valuation"] := "date_of_valuation"
			Result["Common Dividends"] := "common_dividends"
			Result["Return on Equity"] := "return_on_equity"
			Result["Increase in Cash"] := "increase_in_cash"
			Result["Interest Expense"] := "interest_expense"
			Result["Cost of Net Debt"] := "cost_of_net_debt"
			Result["x Total Leverage"] := "x_total_leverage"
			Result["Accounts Payable"] := "accounts_payable"
			Result["Increase in Debt"] := "increase_in_debt"
			Result["Gross Cash Flow"] := "gross_cash_flow"
			Result["Residual Income"] := "residual_income"
			Result["Preferred Stock"] := "preferred_stock"
			Result["This Year's ROE"] := "this_years_roe"
			Result["Deferred Taxes"] := "deferred_taxes"
			Result["Long-Term Debt"] := "longterm_debt"
			Result["Dividends Paid"] := "dividends_paid"
			Result["Valuation Date"] := "valuation_date"
			Result["EBITDA Margin"] := "ebitda_margin"
			Result["Current Ratio"] := "current_ratio"
			Result["Taxes on EBIT"] := "taxes_on_ebit"
			Result["PP&E Turnover"] := "pp_and_e_turnover"
			Result["Company Name:"] := "company_name:"
			Result["Common Equity"] := "common_equity"
			Result["Value of Debt"] := "value_of_debt"
			Result["Sales Growth"] := "sales_growth"
			Result["Forecast EPS"] := "forecast_eps"
			Result["SG&A Expense"] := "sg_and_a_expense"
			Result["Gross Profit"] := "gross_profit"
			Result["Company Name"] := "company_name"
			Result["Cost of Debt"] := "cost_of_debt"
			Result["Gross Margin"] := "gross_margin"
			Result["Current Debt"] := "current_debt"
			Result["Other Assets"] := "other_assets"
			Result["Total Assets"] := "total_assets"
			Result["Income Taxes"] := "income_taxes"
			Result["Entity Value"] := "entity_value"
			Result["Apple Watch"] := "apple_watch"
			Result["Inventories"] := "inventories"
			Result["Interaction"] := "interaction"
			Result["Sales (Net)"] := "sales_net"
			Result["R&D Expense"] := "r_and_d_expense"
			Result["Intangibles"] := "intangibles"
			Result["Investments"] := "investments"
			Result["Fiscal Year"] := "fiscal_year"
			Result["Quick Ratio"] := "quick_ratio"
			Result["Receivables"] := "receivables"
			Result["EBIT Margin"] := "ebit_margin"
			Result["APPLE INC."] := "apple_inc"
			Result["YoY Growth"] := "yoy_growth"
			Result["Machintosh"] := "machintosh"
			Result["PP&E (Net)"] := "pp_and_e_net"
			Result["SG&A/Sales"] := "sg_and_a_over_sales"
			Result["Net Income"] := "net_income"
			Result["Macintosh"] := "macintosh"
			Result["R&D/Sales"] := "r_and_d_over_sales"
			Result["Other (M)"] := "other_m"
			Result["Earnings"] := "earnings"
			Result["iPhone"] := "iphone"
			Result["EBITDA"] := "ebitda"
			Result["Assets"] := "assets"
			Result["NOPLAT"] := "noplat"
			Result["Sales"] := "sales"
			Result["iPod"] := "ipod"
			Result["EBIT"] := "ebit"
			Result["iPad"] := "ipad"
			Result["EBT"] := "ebt"
		end

	bloomberg_iso : HASH_TABLE[STRING_32,STRING_32]
		once
			create Result.make(100)
			Result["NM"] := ""
			Result["LI"] := ""
			Result["KS"] := "KOR"
			Result["US"] := "USA"
			Result["VX"] := ""
			Result["AR"] := "ARG"
			Result["AU"] := "AUS"
			Result["AV"] := "AUT"
			Result["BI"] := "BHR"
			Result["BD"] := "BGD"
			Result["BA"] := "BRB"
			Result["RB"] := "BLR"
			Result["BB"] := "BEL"
			Result["BG"] := "BWA"
			Result["BZ"] := "BRA"
			Result["BU"] := "BGR"
			Result["CN"] := "CAN"
			Result["CI"] := "CHL"
			Result["CH"] := "CHN"
			Result["CB"] := "COL"
			Result["CR"] := "CRI"
			Result["CZ"] := "HRV"
			Result["CY"] := "CYP"
			Result["CP"] := "CZE"
			Result["DC"] := "DNK"
			Result["ED"] := "ECU"
			Result["EY"] := "EGY"
			Result["ET"] := "EST"
			Result["FH"] := "FIN"
			Result["FP"] := "FRA"
			Result["GR"] := "DEU"
			Result["GN"] := "GHA"
			Result["GA"] := "GRC"
			Result["HK"] := "HKG"
			Result["HB"] := "HUN"
			Result["IN"] := "IND"
			Result["IJ"] := "IDN"
			Result["IE"] := "IRN"
			Result["ID"] := "IRL"
			Result["IT"] := "ISR"
			Result["IM"] := "ITA"
			Result["IA"] := "CIV"
			Result["JA"] := "JAM"
			Result["JP"] := "JPN"
			Result["JR"] := "JOR"
			Result["KZ"] := "KAZ"
			Result["KN"] := "KEN"
			Result["KK"] := "KWT"
			Result["LR"] := "LVA"
			Result["LB"] := "LBN"
			Result["LE"] := "LIE"
			Result["LH"] := "LTU"
			Result["LX"] := "LUX"
			Result["MK"] := "MYS"
			Result["MV"] := "MLT"
			Result["MP"] := "MUS"
			Result["MM"] := "MEX"
			Result["MC"] := "MAR"
			Result["NW"] := "NAM"
			Result["NA"] := "NLD"
			Result["NZ"] := "NZL"
			Result["NL"] := "NGA"
			Result["NO"] := "NOR"
			Result["OM"] := "OMN"
			Result["PA"] := "PAK"
			Result["PP"] := "PAN"
			Result["PE"] := "PER"
			Result["PM"] := "PHL"
			Result["PW"] := "POL"
			Result["PL"] := "PRT"
			Result["QD"] := "QAT"
			Result["RO"] := "ROU"
			Result["RU"] := "RUS"
			Result["AB"] := "SAU"
			Result["SG"] := "SRB"
			Result["SP"] := "SGP"
			Result["SK"] := "SVK"
			Result["SV"] := "SVN"
			Result["SJ"] := "ZAF"
			Result["SM"] := "ESP"
			Result["SS"] := "SWE"
			Result["SL"] := "LKA"
			Result["SW"] := "CHE"
			Result["TT"] := "TWN"
			Result["TB"] := "THA"
			Result["TP"] := "TTO"
			Result["TU"] := "TUN"
			Result["TI"] := "TUR"
			Result["UZ"] := "UKR"
			Result["UH"] := "ARE"
			Result["LN"] := "GBR"
			Result["UY"] := "URY"
			Result["VC"] := "VEN"
			Result["VN"] := "VNM"
			Result["ZH"] := "ZWE"
		end
	read_consensus_sheet (a_record : RL_CONSENSUS_SHEET_RECORD)
		do
			consensus_sheet_records[a_record.id] := a_record
			consensus_sheets_by_ticker[a_record.ticker] := a_record
		end
	excel_to_csv : STRING_8 = "[
import openpyxl
import glob
import os
import sys
excel = sys.argv[1]
dir = sys.argv[2]
print(excel)
print(dir)
try:
    wb = openpyxl.load_workbook(excel,data_only=True)
    for df in wb.worksheets:
        if 'w-links' in df.title:
            out = dir + '/' + df.title+'.csv'
            print(out)
            import csv
            with open(out, 'w', newline='') as csvfile:
                wr = csv.writer(csvfile, delimiter='\t')
                for row in df.rows:
                    lrow = []
                    for cell in row:
                           lrow.append(getattr(cell,"value",None))
                    wr.writerow(lrow)
            print(" ... done")
            csvfile.close()
except:
    pass
]"

	relay_port_cell : separate CELL[INTEGER]
		once ("process")
			create Result.put(0)
		end

	set_relay_port(a_port : INTEGER)
		do
			set_relay_port_cell(relay_port_cell,a_port)
		end

	set_relay_port_cell (a_cell : separate CELL[INTEGER];a_port : INTEGER)
		do
			a_cell.put (a_port)
		end

	relay_port : INTEGER
		do
			separate relay_port_cell as s_port do
				Result := s_port.item
			end
		end

--	load_us_industries
--		local
--			l_file : RAW_FILE
--			l_year,l_month,l_day : INTEGER
--			l_delimited : RL_DELIMITED_TEXT
--			l_date : RL_DATE
--			l_barrid,l_industry : STRING_32
--			l_command : RL_POSTGRES_COMMAND[TUPLE[date,barrid,industry : STRING_32; exposure : REAL_64]]
--		do
--			create l_command.make (postgres, "insert into exposures (datadate,barrid,industry,exposure) values ($1,$2,$3,44)")
--			create l_file.make_open_read("/Users/markhoward/wrds/us_industries.csv")
--			from l_file.read_line until l_file.off loop
--				if l_file.last_string[1] /= '%"' then
--					create l_delimited.make (l_file.last_string, '|')
--					l_year := l_delimited[2].substring (1, 4).to_integer
--					l_month := l_delimited[2].substring (6,7).to_integer
--					l_day := l_delimited[2].substring (9, 10).to_integer
--					create l_date.make(l_year,l_month,l_day)
--					l_barrid := l_delimited[1]
--					l_industry := l_delimited[3]
--					l_command.execute([l_date.iso_out,l_barrid,l_industry,l_delimited[4].to_real_64])
--				end
--				l_file.read_line
--			end
--		end

	save_global (a_output : like statement_output_template;a_statement : RL_BLOOMBERG_STATEMENT_RECORD;a_record : RL_GFUNDA_RECORD)
		do
			if a_record.at.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"at",a_record.at]) end
			if a_record.act.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"act",a_record.act]) end
			if a_record.ppent.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ppent",a_record.ppent]) end
			if a_record.ivaeq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ivaeq",a_record.ivaeq]) end
			if a_record.ivao.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ivao",a_record.ivao]) end
			if a_record.intan.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"intan",a_record.intan]) end
			if a_record.ao.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ao",a_record.ao]) end
			if a_record.che.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"che",a_record.che]) end
			if a_record.ch.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ch",a_record.ch]) end
			if a_record.ivst.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ivst",a_record.ivst]) end
			if a_record.act.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"act",a_record.act]) end
			if a_record.che.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"che",a_record.che]) end
			if a_record.rect.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rect",a_record.rect]) end
			if a_record.invt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invt",a_record.invt]) end
			if a_record.aco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aco",a_record.aco]) end
			if a_record.ao.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ao",a_record.ao]) end
			if a_record.dc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dc",a_record.dc]) end
			if a_record.unl.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"unl",a_record.unl]) end
			if a_record.ea.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ea",a_record.ea]) end
			if a_record.aox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aox",a_record.aox]) end
			if a_record.dlc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dlc",a_record.dlc]) end
			if a_record.dd1.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dd1",a_record.dd1]) end
			if a_record.np.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"np",a_record.np]) end
			if a_record.lct.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lct",a_record.lct]) end
			if a_record.dlc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dlc",a_record.dlc]) end
			if a_record.ap.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ap",a_record.ap]) end
			if a_record.lco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lco",a_record.lco]) end
			if a_record.invt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invt",a_record.invt]) end
			if a_record.invrm.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invrm",a_record.invrm]) end
			if a_record.invwip.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invwip",a_record.invwip]) end
			if a_record.invfg.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invfg",a_record.invfg]) end
			if a_record.invo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invo",a_record.invo]) end
			if a_record.lt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lt",a_record.lt]) end
			if a_record.lct.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lct",a_record.lct]) end
			if a_record.txdb.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txdb",a_record.txdb]) end
			if a_record.dltt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dltt",a_record.dltt]) end
			if a_record.rvutx.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rvutx",a_record.rvutx]) end
			if a_record.lo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lo",a_record.lo]) end
			if a_record.lse.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lse",a_record.lse]) end
			if a_record.lt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lt",a_record.lt]) end
			if a_record.mib.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mib",a_record.mib]) end
			if a_record.teq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"teq",a_record.teq]) end
			if a_record.ppent.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ppent",a_record.ppent]) end
			if a_record.ppegt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ppegt",a_record.ppegt]) end
			if a_record.dpact.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dpact",a_record.dpact]) end
			if a_record.ivgod.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ivgod",a_record.ivgod]) end
			if a_record.seq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"seq",a_record.seq]) end
			if a_record.pstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstk",a_record.pstk]) end
			if a_record.cstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"cstk",a_record.cstk]) end
			if a_record.sco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"sco",a_record.sco]) end
			if a_record.prc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"prc",a_record.prc]) end
			if a_record.tstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"tstk",a_record.tstk]) end
			if a_record.caps.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"caps",a_record.caps]) end
			if a_record.rvlrv.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rvlrv",a_record.rvlrv]) end
			if a_record.re.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"re",a_record.re]) end
			if a_record.unnp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"unnp",a_record.unnp]) end
			if a_record.transa.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"transa",a_record.transa]) end
			if a_record.pstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstk",a_record.pstk]) end
			if a_record.pstkr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstkr",a_record.pstkr]) end
			if a_record.pstkn.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstkn",a_record.pstkn]) end
			if a_record.rect.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rect",a_record.rect]) end
			if a_record.rectr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rectr",a_record.rectr]) end
			if a_record.recco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"recco",a_record.recco]) end
			if a_record.teq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"teq",a_record.teq]) end
			if a_record.seq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"seq",a_record.seq]) end
			if a_record.mibn.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mibn",a_record.mibn]) end
			if a_record.lco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lco",a_record.lco]) end
			if a_record.xacc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xacc",a_record.xacc]) end
			if a_record.txp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txp",a_record.txp]) end
			if a_record.lcox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lcox",a_record.lcox]) end
			if a_record.aco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aco",a_record.aco]) end
			if a_record.xpp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xpp",a_record.xpp]) end
			if a_record.acox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"acox",a_record.acox]) end
			if a_record.xopr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xopr",a_record.xopr]) end
			if a_record.cogs.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"cogs",a_record.cogs]) end
			if a_record.xsga.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xsga",a_record.xsga]) end
			if a_record.stkch.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"stkch",a_record.stkch]) end
			if a_record.capcst.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"capcst",a_record.capcst]) end
			if a_record.xstf.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xstf",a_record.xstf]) end
			if a_record.dp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dp",a_record.dp]) end
			if a_record.dfxa.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dfxa",a_record.dfxa]) end
			if a_record.am.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"am",a_record.am]) end
			if a_record.dvt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dvt",a_record.dvt]) end
			if a_record.dvp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dvp",a_record.dvp]) end
			if a_record.dvc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dvc",a_record.dvc]) end
			if a_record.dvsco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dvsco",a_record.dvsco]) end
			if a_record.nit.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nit",a_record.nit]) end
			if a_record.eiea.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"eiea",a_record.eiea]) end
			if a_record.nio.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nio",a_record.nio]) end
			if a_record.pi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pi",a_record.pi]) end
			if a_record.oiadp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oiadp",a_record.oiadp]) end
			if a_record.xint.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xint",a_record.xint]) end
			if a_record.nopi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nopi",a_record.nopi]) end
			if a_record.oiadp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oiadp",a_record.oiadp]) end
			if a_record.oibdp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oibdp",a_record.oibdp]) end
			if a_record.dp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dp",a_record.dp]) end
			if a_record.ib.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ib",a_record.ib]) end
			if a_record.pi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pi",a_record.pi]) end
			if a_record.autxr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"autxr",a_record.autxr]) end
			if a_record.txt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txt",a_record.txt]) end
			if a_record.mii.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mii",a_record.mii]) end
			if a_record.nit.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nit",a_record.nit]) end
			if a_record.ibmii.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ibmii",a_record.ibmii]) end
			if a_record.pi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pi",a_record.pi]) end
			if a_record.txt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txt",a_record.txt]) end
			if a_record.oibdp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oibdp",a_record.oibdp]) end
			if a_record.revt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"revt",a_record.revt]) end
			if a_record.xopr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xopr",a_record.xopr]) end
			if a_record.revt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"revt",a_record.revt]) end
			if a_record.sale.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"sale",a_record.sale]) end
			if a_record.txt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txt",a_record.txt]) end
			if a_record.txc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txc",a_record.txc]) end
			if a_record.txdi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txdi",a_record.txdi]) end
			if a_record.txo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txo",a_record.txo]) end
			if a_record.xlr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xlr",a_record.xlr]) end
			if a_record.xstfws.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xstfws",a_record.xstfws]) end
			if a_record.xstfo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xstfo",a_record.xstfo]) end
		end

	statement_output_template : RL_DELIMITED_FILE[TUPLE[barrid,sheet,ticker,country : STRING_32;sheet_id : INTEGER;date : RL_DATE;mnemonic : STRING_8;value : REAL_64]] attribute check false then end end
	save_na (a_output : like statement_output_template;a_statement : RL_BLOOMBERG_STATEMENT_RECORD;a_record : RL_FUNDA_RECORD)
		do
			if a_record.aco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aco",a_record.aco]) end
			if a_record.xpp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xpp",a_record.xpp]) end
			if a_record.acox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"acox",a_record.acox]) end
			if a_record.act.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"act",a_record.act]) end
			if a_record.che.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"che",a_record.che]) end
			if a_record.rect.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rect",a_record.rect]) end
			if a_record.invt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invt",a_record.invt]) end
			if a_record.aco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aco",a_record.aco]) end
			if a_record.ao.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ao",a_record.ao]) end
			if a_record.dc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dc",a_record.dc]) end
			if a_record.aox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"aox",a_record.aox]) end
			if a_record.ceq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ceq",a_record.ceq]) end
			if a_record.cstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"cstk",a_record.cstk]) end
			if a_record.caps.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"caps",a_record.caps]) end
			if a_record.re.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"re",a_record.re]) end
			if a_record.tstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"tstk",a_record.tstk]) end
			if a_record.che.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"che",a_record.che]) end
			if a_record.ch.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ch",a_record.ch]) end
			if a_record.ivst.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ivst",a_record.ivst]) end
			if a_record.dlc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dlc",a_record.dlc]) end
			if a_record.dd1.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dd1",a_record.dd1]) end
			if a_record.np.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"np",a_record.np]) end
			if a_record.intan.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"intan",a_record.intan]) end
			if a_record.gdwl.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"gdwl",a_record.gdwl]) end
			if a_record.intano.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"intano",a_record.intano]) end
			if a_record.invt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invt",a_record.invt]) end
			if a_record.invrm.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invrm",a_record.invrm]) end
			if a_record.invwip.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invwip",a_record.invwip]) end
			if a_record.invfg.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invfg",a_record.invfg]) end
			if a_record.invo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"invo",a_record.invo]) end
			if a_record.lco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lco",a_record.lco]) end
			if a_record.xacc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xacc",a_record.xacc]) end
			if a_record.lcox.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lcox",a_record.lcox]) end
			if a_record.lct.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lct",a_record.lct]) end
			if a_record.dlc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dlc",a_record.dlc]) end
			if a_record.ap.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ap",a_record.ap]) end
			if a_record.txp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txp",a_record.txp]) end
			if a_record.lco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lco",a_record.lco]) end
			if a_record.lse.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lse",a_record.lse]) end
			if a_record.lt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lt",a_record.lt]) end
			if a_record.mib.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mib",a_record.mib]) end
			if a_record.teq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"teq",a_record.teq]) end
			if a_record.lt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lt",a_record.lt]) end
			if a_record.lct.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lct",a_record.lct]) end
			if a_record.dltt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dltt",a_record.dltt]) end
			if a_record.txditc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txditc",a_record.txditc]) end
			if a_record.lo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"lo",a_record.lo]) end
			if a_record.mibt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mibt",a_record.mibt]) end
			if a_record.mib.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mib",a_record.mib]) end
			if a_record.mibn.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mibn",a_record.mibn]) end
			if a_record.ppent.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ppent",a_record.ppent]) end
			if a_record.ppegt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ppegt",a_record.ppegt]) end
			if a_record.dpact.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dpact",a_record.dpact]) end
			if a_record.pstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstk",a_record.pstk]) end
			if a_record.pstkr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstkr",a_record.pstkr]) end
			if a_record.pstkn.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstkn",a_record.pstkn]) end
			if a_record.rect.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rect",a_record.rect]) end
			if a_record.rectr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"rectr",a_record.rectr]) end
			if a_record.recco.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"recco",a_record.recco]) end
			if a_record.seq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"seq",a_record.seq]) end
			if a_record.pstk.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pstk",a_record.pstk]) end
			if a_record.ceq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ceq",a_record.ceq]) end
			if a_record.teq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"teq",a_record.teq]) end
			if a_record.seq.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"seq",a_record.seq]) end
			if a_record.mibn.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mibn",a_record.mibn]) end
			if a_record.txditc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txditc",a_record.txditc]) end
			if a_record.txdb.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txdb",a_record.txdb]) end
			if a_record.ib.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ib",a_record.ib]) end
			if a_record.ibmii.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ibmii",a_record.ibmii]) end
			if a_record.mii.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"mii",a_record.mii]) end
			if a_record.ibmii.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"ibmii",a_record.ibmii]) end
			if a_record.pi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pi",a_record.pi]) end
			if a_record.txt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txt",a_record.txt]) end
			if a_record.nopi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nopi",a_record.nopi]) end
			if a_record.idit.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"idit",a_record.idit]) end
			if a_record.oiadp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oiadp",a_record.oiadp]) end
			if a_record.oibdp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oibdp",a_record.oibdp]) end
			if a_record.dp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"dp",a_record.dp]) end
			if a_record.oibdp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oibdp",a_record.oibdp]) end
			if a_record.sale.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"sale",a_record.sale]) end
			if a_record.xopr .abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xopr ",a_record.xopr ]) end
			if a_record.pi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"pi",a_record.pi]) end
			if a_record.oiadp.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"oiadp",a_record.oiadp]) end
			if a_record.xint.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xint",a_record.xint]) end
			if a_record.nopi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"nopi",a_record.nopi]) end
			if a_record.spi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"spi",a_record.spi]) end
			if a_record.txt.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txt",a_record.txt]) end
			if a_record.txc.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txc",a_record.txc]) end
			if a_record.txdi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txdi",a_record.txdi]) end
			if a_record.txo.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"txo",a_record.txo]) end
			if a_record.xido.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xido",a_record.xido]) end
			if a_record.xi.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xi",a_record.xi]) end
			if a_record.do_.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"do_",a_record.do_]) end
			if a_record.xopr.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xopr",a_record.xopr]) end
			if a_record.cogs.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"cogs",a_record.cogs]) end
			if a_record.xsga.abs > .000000001 then a_output.put_row([a_statement.barrid,a_statement.sheet,a_statement.ticker,a_statement.country,a_statement.sheet_id,a_statement.end_date,"xsga",a_record.xsga]) end
		end

	barra_isin_local_query : RL_POSTGRES_QUERY[RL_ENLIS_BARRID_RECORD,TUPLE[id,iso : STRING_32]]
		once
			create Result.make(barra,"[
						select a.barrid,b.localid,a.country_of_q_id,c.isin,
						greatest(a.startdate,b.startdate,c.startdate) as first,
						least(a.enddate,b.enddate,c.enddate) as last from 
						equityidentity_master a, localid_master b,isin_master c
						where a.barrid = b.barrid 
						and b.localid = $1
						and a.country_of_q_id = $2	
						and c.barrid = a.barrid
						and greatest(a.startdate,b.startdate,c.startdate) < least(a.enddate,b.enddate,c.enddate)
						group by least(a.enddate,b.enddate,c.enddate),
						greatest(a.startdate,b.startdate,c.startdate),a.barrid,b.localid,c.isin,a.country_of_q_id
				]")
		end

end
