note
	description: "Summary description for {RL_ENLIS_REQUEST}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_ENLIS_REQUEST
inherit
	RL_ENLIS_SERVER_REQUEST
	RL_ENLIS_AWARE
	RL_ENLIS_ENDPOINTS
	RL_ULISSES_AWARE
create
	make
feature
	make (a_server : like request_handler)
		do
			request_handler := a_server
			actions[c__initialize] := agent handle_initialize
			actions[c__ticker__forecast] := agent handle_ticker_forecast
			actions[c__variable__expand] := agent handle_variable_expand
			actions[c__set__valuation_parameters] := agent handle_set_valuation_parameters
			actions[c__autocomplete] := agent handle_autocomplete
			actions[c__graph] := agent handle_graph
			actions["/search"] := agent handle_ulisses_autocomplete
			actions["/override"] := agent handle_override
			actions["/expand"] := agent handle_expand
			actions["/select_cell"] := agent handle_select_cell
			actions["/ticker/reconcile"] := agent handle_statements
		end
	handle_expand (a_request : RL_REQUEST)
		local
			l_response,l_request : RL_JSON_STRUCTURE
			l_children : RL_JSON_ARRAY
			l_id : INTEGER
		do
			create l_response
			create l_request
			create l_children
			if attached a_request.string_8_value (c_uuid) as al_uuid
			and then attached a_request.string_8_value(c_node_uuid) as al_node_uuid
			and then attached forecasts(al_uuid) as al_forecasts then
				separate al_forecasts as s_forecasts do
					create l_children.make_from_separate (s_forecasts.node_children(al_node_uuid,Void))
				end
			end
			l_response.put (l_children, <<"grid">>)
			a_request.set_response (l_response)
		end
	handle_select_cell (a_request : RL_REQUEST)
		local
			l_response : RL_JSON_STRUCTURE
		do
			create l_response
			if attached a_request.string_8_value (c_uuid) as al_uuid
			and then attached forecasts(al_uuid) as al_forecasts then
				separate al_forecasts as s_forecasts do
					s_forecasts.set_grid(a_request.integer_value (c_id))
					create l_response.make_from_separate(s_forecasts.grid.displayed)
				end
			end
			a_request.set_response (l_response)
		end
--	grid : like node_template attribute create Result.make_top(agent empty_display,agent expand_computation,["",0]) end
--	handle_variable_grid(a_request : RL_REQUEST)
--		local
--			l_id : INTEGER
--			l_response,l_structure : RL_JSON_STRUCTURE
--			l_computations : RL_JSON_ARRAY
--			l_computation :  separate RL_ENLIS_COMPUTATION[REAL_64]
--			l_delimited : RL_DELIMITED_TEXT
--			l_path,l_uuid : STRING_8
--			l_file : RAW_FILE
--		do
--			l_path := a_request.string_8_value ("path")
--			l_uuid := a_request.string_8_value ("uuid")
--			create l_response
--			if attached forecasts(l_uuid) as al_forecasts
--			and then attached l_path then
--				separate al_forecasts as s_forecasts do
--					create l_delimited.make (l_path, ':')
--					if attached l_delimited.last as al_last
--					and then al_last.is_integer then
--						l_id := al_last.to_integer
--						if attached s_forecasts.computations[l_id] as al_computation then
--							create l_computations.make_empty
--							separate al_computation as s_computation do
--								create l_computations.make_from_separate (s_computation.subexpressions_json(l_path))
--							end
--							l_response.put (l_computations, <<"subexpressions">>)
--						end
--					else
--						l_response.put_string ("Unknown computation " + l_path, "Error")
--					end
--				end
--			end
--			a_request.set_response (l_response)
--		end
--	empty_display (a_node : like node_template) : RL_JSON_CELLS
--		do
--			create Result
--		end
--	display_row(a_node : RL_JSON_GRID_NODE[TUPLE];i,a_depth : INTEGER) : RL_JSON_CELLS
--		do
--			create Result.make (<<["row",i.out,Void],["depth",a_depth.out,Void]>>)
--		end
--	node_template : RL_JSON_GRID_NODE[TUPLE[uuid : STRING_8;id : INTEGER]] do check false then end end
--	expand_computation(a_node :  like node_template;a_query : RL_JSON_STRUCTURE) : RL_LIST[like node_template]
--		local
--			l_uuid : STRING_8
--			l_id : INTEGER
--			l_node : like node_template
--			l_computation : separate RL_ENLIS_COMPUTATION[REAL_64]
--		do
--			if a_node = grid then
--				Result := requested_computations
--			else
--				create Result
--				l_uuid := a_node.data.uuid
--				l_id := a_node.data.id
--				if attached l_uuid
--				and then attached forecasts(l_uuid) as al_forecasts then
--					separate al_forecasts as s_forecasts do
--						if attached s_forecasts.computations[l_id] as al_computation then
--							across al_computation.subexpressions as ic_subexpressions loop
--								l_computation := ic_subexpressions.item
--								separate l_computation as s_computation do
--									create l_node.make (a_node,
--										agent display_computation,
--										agent expand_computation,[a_node.data.uuid,s_computation.id])
--									Result.extend (l_node)
--								end
--							end
--						end
--					end
--				end
--			end
--		end
--	display_computation (a_node : like node_template) : RL_JSON_CELLS
--		local
--			l_name,l_record : STRING_32
--		do
--			if attached forecasts(a_node.data.uuid) as al_forecasts then
--				separate al_forecasts as s_forecasts do
--					if attached s_forecasts.computations[a_node.data.id] as al_computation then
--						create l_name.make_from_separate (al_computation.name)
--						create l_record.make_from_separate (al_computation.record.name)
--						create Result.make(<< ["record",l_record,Void],
--											["name",l_name,Void],
--											["value",al_computation.value.out.as_string_32,Void],
--											["id",al_computation.id.out.as_string_32,Void]>>)
--					end
--				end
--			end
--			if not attached Result then
--				create Result.make (<<["","",Void]>>)
--			end
--		end
--	requested_computations : RL_LIST[like node_template]
--		attribute
--			create Result
--		end
--	expand_row(a_node :  RL_JSON_GRID_NODE[TUPLE];a_query : RL_JSON_STRUCTURE;a_depth : INTEGER) : RL_LIST[RL_JSON_GRID_NODE[TUPLE]]
--		local
--			i : INTEGER
--			l_node : RL_JSON_GRID_NODE
--			l_list : RL_LIST[RL_JSON_GRID_NODE[TUPLE]]
--		do
--			create Result
--			from i := 1 until i > 10 loop
--				create l_node.make (a_node, agent display_row(?,i,a_depth),agent expand_row(?,?,a_depth+1))
--				Result.extend (l_node)
--				i := i + 1
--			end
--		end
	handle_initialize(a_request : RL_REQUEST)
		local
			l_valuation_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_response : RL_JSON_STRUCTURE
			l_company : RL_NA_COMPANY
			l_uuid : STRING_8
		do
			create l_response
			create l_company.make ("")
			l_uuid := uuids.generate_uuid.out
			create l_valuation_parameters.make_annual (l_company, 0, 0, create {RL_DATE}.make_now)
			l_response.put (l_valuation_parameters.to_json, <<"valuation_parameters">>)
			l_response.put_string (l_uuid, "uuid")
			a_request.set_response (l_response)
		end
	handle_autocomplete(a_request : RL_REQUEST)
		local
			l_array : RL_JSON_ARRAY
			l_tickers,l_names,l_records : RL_LIST[RL_ENLIS_BARRID_RECORD]
			l_response,l_record : RL_JSON_STRUCTURE
		do
			create l_response
			if attached a_request.string_32_value ("name") as al_name then
				l_tickers := autocomplete_ticker_query.retrieved([(al_name.as_lower + "%%").as_string_32])
				l_names := autocomplete_name_query.retrieved([("%%" + al_name.as_lower + "%%").as_string_32])
				create l_records
				l_records.append (l_tickers)
				l_records.append (l_names)
				create l_array.make_empty
				across l_records as ic_records loop
					create l_record.make (<<	["name",ic_records.item.issue_name],
											["barrid",ic_records.item.barrid],
											["ticker",ic_records.item.localid]
											>>)
					l_array.extend(l_record)
				end
				l_response.put(l_array,<<"names">>)
			end
			a_request.set_response (l_response)
		end
	handle_ticker_forecast(a_request : RL_REQUEST)
		local
			l_ticker,l_barra,l_name : STRING_32
			l_forecasts : separate RL_ENLIS_FORECASTS
			l_company : RL_COMPANY
			l_computation : RL_ENLIS_COMPUTATION[REAL_64]
			l_response,l_computation_structure,l_years : RL_JSON_STRUCTURE
			l_computation_lists : RL_JSON_ARRAY
			l_computations : RL_LIST[RL_ENLIS_COMPUTATION[REAL_64]]
			l_computations_table : TUPLE_KEYED_HASH_TABLE[RL_LIST[RL_ENLIS_COMPUTATION[REAL_64]],TUPLE[sheet,variable : STRING_32]]
			l_valuation_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_delimited : RL_DELIMITED_TEXT_32
			l_date : RL_DATE
			l_sheet : RL_ENLIS_RECORD
			i,l_year,l_month,l_day : INTEGER
			l_record : RL_ENLIS_BARRID_RECORD
			l_verbose : BOOLEAN
			l_uuid : STRING_8
		do
			l_ticker := a_request.string_32_value ("ticker")
			l_barra := a_request.string_32_value ("barrid")
			l_name := a_request.string_32_value ("name")
			l_verbose := a_request.boolean_value ("verbose")
			l_uuid := a_request.string_8_value ("uuid")
			create l_response
			if attached l_uuid then
				create l_date.make_today
				l_year := l_date.year
--				if attached l_barra
--				and then l_barra /~ "" then
--					create l_company.make_from_barra (l_barra)
--				elseif attached l_ticker
--				and then l_ticker /~ "" then
--					l_ticker.to_upper
--					create l_company.make_na (l_ticker)
--				elseif attached l_name
--				and then l_name /~ "" then
--					create l_company.make_from_name (l_name)
--				end
--				if not attached l_company then
--					create l_company.make_na ("AAPL")
--				end
--				create l_valuation_parameters.make (l_company, l_year, 5, l_date)
	--			if attached {RL_JSON_STRUCTURE} a_request.value ("valuation_parameters") as al_structure then
	--				create l_valuation_parameters.make (l_company, 2015, 5, l_date)
	--				l_valuation_parameters.set_cost_of_common_equity(al_structure.real_64_value ("cost_of_common_equity"))
	--				l_valuation_parameters.set_value_of_contingent_equity_class(al_structure.real_64_value ("value_of_contingent_equity_class"))
	--				l_valuation_parameters.set_dilution_factor_for_splits(al_structure.real_64_value ("_dilution_factor_for_splits"))
	--				l_valuation_parameters.set_cost_of_debt(al_structure.real_64_value ("cost_of_debt"))
	--				l_valuation_parameters.set_cost_of_preferred_stock(al_structure.real_64_value ("cost_of_preferred_stock"))
	--				l_valuation_parameters.set_cost_of_minority_interest(al_structure.real_64_value ("cost_of_minority_interest"))
	--				l_valuation_parameters.set_after_tax_weighted_average_cost_of_capital(al_structure.real_64_value ("after_tax_weighted_average_cost_of_capital"))
	--			end
				if not attached l_barra then
					l_barra := ""
				end
				separate forecasts_manager as s_manager do
					l_name := ""
					l_forecasts := s_manager.added_forecasts(l_barra,l_uuid,l_verbose)
	--				create l_forecasts.make_barra (l_company,l_verbose)
					create l_computations.make_empty
--					create l_computation_lists.make_empty
					create l_computations_table.make (1000)
					separate l_forecasts as s_forecasts do
						create l_name.make_from_separate(s_forecasts.company.name)
						create l_computation_lists.make_from_separate (s_forecasts.panel_json)
--						s_forecasts.
--						across s_forecasts.sheets as ic_sheets loop
--							from i := s_forecasts.first_year until i > s_forecasts.nth_year loop
--								across ic_sheets.item[i].computations.table as ic_computations loop
--									ic_computations.item.do_nothing
--								end
--								i := i + 1
--							end
--							l_sheet := ic_sheets.item[s_forecasts.first_year]
--							across l_sheet.computations.table as ic_computations loop
--								l_computation := ic_computations.item
--								l_computation_structure := l_forecasts.vector_json(l_computation)
--								l_computation_lists.extend (l_computation_structure)
--							end
--						end
					end
					l_response.put_string (l_name, "name")
					l_response.put (l_computation_lists, <<"variables">>)
				end
			end
			a_request.set_response (l_response)
		end
	next_id : INTEGER
		do
			next_id_cell.put(next_id_cell.item + 1)
			Result := next_id_cell.item
		end
	next_id_cell : CELL[INTEGER]
		once
			create Result.put(0)
		end
	handle_ulisses_autocomplete(a_request : RL_REQUEST)
		local
			l_list : like entities.bloomberg_id_securities
			l_array : RL_JSON_ARRAY
			l_keyed : like entities.bloomberg_id_securities.item
			l_found : like entities.bloomberg_id_securities.binary_search
			l_response,l_record : RL_JSON_STRUCTURE
			l_security : RL_SECURITY
			l_securities : HASH_TABLE[RL_SECURITY,STRING_8]
			l_end_date : RL_DATE
			l_ticker_interval,l_barrid_interval : RL_IDENTIFIER_INTERVAL
			i : INTEGER
		do
			create l_end_date.make_today
			l_list := entities.bloomberg_id_securities
			create l_securities.make (10)
			create l_response
			if attached a_request.string_32_value ("name") as al_name then
				l_found := l_list.found (al_name)
				create l_array.make_empty
				from i := l_found.upper_bound until i = 0 or else i > l_list.count or else not l_list[i].key.starts_with (al_name.as_upper) loop
					l_security := l_list[i].item
					if attached l_security then
						l_securities[l_security.id] := l_security
					end
					i := i + 1
				end
				across l_securities as ic_securities loop
					l_security := ic_securities.item
					create l_record
					l_record.put_string (l_security.name, "name")
					across l_security.bloomberg_ids as ic_ids loop
						if ic_ids.item.end_date > l_end_date then
							l_record.put_string (ic_ids.item.key, "ticker")
						end
					end
					across l_security.isins as ic_ids loop
						if ic_ids.item.end_date > l_end_date then
							l_record.put_string (ic_ids.item.key, "isin")
						end
					end
					l_array.extend(l_record)
				end
				l_response.put(l_array,<<"names">>)
			end
			a_request.set_response (l_response)
		end
	handle_override(a_request : RL_REQUEST)
		local
			l_overrides,l_years,l_response,l_cell,l_override : RL_JSON_STRUCTURE
			l_item : RL_ULISSES_ITEM
			l_sheet_key,l_periodicity : STRING_32
			l_statement : RL_ULISSES_STATEMENT
			l_reports : HASH_TABLE[RL_ULISSES_SHEET,STRING_32]
			l_sheet : RL_ULISSES_SHEET
			l_modified : HASH_TABLE[RL_ULISSES_STATEMENT,STRING_8]
			l_values : HASH_TABLE[REAL_64,STRING_8]
			l_variables : RL_JSON_ARRAY
			l_variable,l_sheet_json : RL_JSON_STRUCTURE
			l_end_date : RL_DATE
			l_row,i : INTEGER
			l_security_id : STRING_8
			l_security : RL_SECURITY
			l_affected : RL_LIST[RL_ULISSES_ITEM]
		do
			create l_response
			create l_variables
			create l_affected
			l_response.put (l_variables, <<"variable">>)
			l_overrides := a_request.structure_value ("overrides")
			l_security_id := a_request.string_8_value ("security")
			l_periodicity := a_request.string_32_value ("periodicity")
			if attached l_security_id
			and  then attached l_periodicity then
				l_security := entities.securities[l_security_id]
				if attached l_security then
					l_reports := security_statements(l_security,l_periodicity)
				end
			end
			create l_modified.make (10)
			if attached l_overrides
			and then attached l_security
			and then attached l_reports then
				across l_overrides.item.table as ic_overrides loop
					l_sheet_key := ic_overrides.key
					l_sheet := l_reports[l_sheet_key]
					if attached l_sheet
					and then attached {RL_JSON_STRUCTURE} ic_overrides.item as al_rows then
						across al_rows.item.table as ic_rows loop
							if ic_rows.key.is_integer then
								l_row := ic_rows.key.to_integer
								if attached {RL_JSON_STRUCTURE} ic_rows.item as al_line then
									across al_line.item.table as ic_periods loop
										create l_end_date.make_from_iso (ic_periods.key)
										l_statement := l_sheet.statements[l_end_date]
										if attached l_statement then
											l_item := l_statement.lines[l_row]
											if not attached l_item then
												if attached l_sheet.variables[l_row] as al_variable then
													create l_item.make (l_statement, al_variable, 0, l_sheet.parents[l_row], l_row)
													l_statement.add_item (l_item)
												end
											end
											if attached l_item then
												if attached {RL_JSON_UTF8_STRING} ic_periods.item as al_value then
													if al_value.item.is_real_64 then
														l_item.set_override(al_value.item.to_real_64)
													end
												end
												l_affected.extend (l_item)
											end
											l_modified[l_statement.uuid] := l_statement
										end
									end
								end
							end
						end
					end
				end
				across l_modified as ic_statements loop
					l_statement := ic_statements.item
					create l_values.make (l_statement.line_items.count)
					across l_statement.line_items as ic_items loop
						l_values[ic_items.item.uuid] := ic_items.item.computed
					end
					across l_statement.line_items as ic_items loop
						ic_items.item.set_is_computed(False)
					end
					across l_statement.line_items as ic_items loop
						l_item := ic_items.item
						if (l_item.computed - l_values[l_item.uuid]).abs > .001 then
							l_affected.extend (l_item)
						end
					end
					across l_affected as ic_affected loop
						l_item := ic_affected.item
						create l_variable
						create l_cell
						l_variable.put_string (l_statement.sheet.name, "sheet")
						l_variable.put_string (l_item.variable, "variable")
						l_variable.put_integer (l_item.index, "row")
						create l_years
						l_cell := l_item.to_json
						l_cell.put_boolean (True, "modified")
						l_cell.put_string(l_statement.end_date.date.out,"end_date")
						l_years.put(l_cell,<<l_statement.end_date.out>>)
						l_variable.put (l_years, <<"years">>)
						l_variables.extend (l_variable)
					end
				end
			end
			a_request.set_response(l_response)
		end

	handle_statements(a_request : RL_REQUEST)
		local
			l_ticker,l_isin,l_name,l_periodicity : STRING_32
			l_security : RL_SECURITY
			l_response : RL_JSON_STRUCTURE
			l_verbose : BOOLEAN
			l_statement : RL_ULISSES_STATEMENT
			l_sheet : RL_ULISSES_SHEET
			l_statements : like security_statements
			l_years,l_variable,l_cell : RL_JSON_STRUCTURE
			l_variables : RL_JSON_ARRAY
			i,l_max : INTEGER
			l_columns : HASH_TABLE[BOOLEAN,STRING_32]
			l_columns_json : RL_JSON_ARRAY
			l_column_list : RL_LIST[STRING_32]
		do
			l_ticker := a_request.string_32_value ("ticker")
			l_isin := a_request.string_32_value ("isin")
			l_name := a_request.string_32_value ("name")
			l_verbose := a_request.boolean_value ("verbose")
			l_periodicity := a_request.string_32_value ("periodicity")
			if not attached l_periodicity then
				l_periodicity := "annual"
			end
			create l_response
			create l_columns.make (20)
			if attached l_isin then
				l_security := entities.isin_securities.found_item(l_isin)
			end
			if attached l_security then
				create l_response
				l_statements := security_statements(l_security,l_periodicity)
				l_response.put_string(l_security.name,"name")
				l_response.put_string(l_security.id,"security")
				create l_variables
				l_response.put (l_variables, <<"variables">>)
				if attached l_statements then
					across l_statements as ic_sheets loop
						l_sheet := ic_sheets.item
						across l_sheet.statements as ic_periods loop
							l_statement := ic_periods.item
							l_max := l_max.max (l_statement.max_line)
						end
						from i := 1 until i > l_max loop
							create l_years
							create l_variable
							l_variables.extend (l_variable)
							across l_sheet.statements as ic_periods loop
								l_statement := ic_periods.item
								if attached l_statement.lines[i] as al_line then
									if l_variable.is_empty then
										l_variable.put_string (ic_sheets.key, "sheet")
										l_variable.put_integer (i, "row")
										l_variable.put_string (al_line.variable, "variable")
										l_variable.put (l_years, <<"years">>)
									end
									l_columns[ic_periods.key.out] := True
									l_cell := al_line.to_json
									l_cell.put_string(ic_periods.key.out,"end_date")
									l_years.put (l_cell,<<ic_periods.key.out>>)
								end
							end
							i := i+ 1
						end
					end
				end
			end
			create l_column_list
			across l_columns as ic_columns loop
				l_column_list.extend (ic_columns.key)
			end
			l_column_list.sort_by (agent string_less)
			create l_columns_json
			across l_column_list as ic_columns loop
				l_columns_json.extend_string_32 (ic_columns.item)
			end
			l_response.put(l_columns_json,<<"columns">>)
			a_request.set_response (l_response)
		end


	string_less (a_1,a_2 : STRING_32) : BOOLEAN
		do
			Result := a_1 < a_2
		end

	handle_ulisses_graph(a_request : RL_REQUEST)
		local
			l_response : RL_JSON_STRUCTURE
			l_nodes,l_links : RL_JSON_ARRAY
			l_node : RL_GRAPH_NODE
			l_link : RL_GRAPH_LINK
			l_id : INTEGER
			l_seen_nodes : RL_STRING_TABLE[BOOLEAN]
			l_seen_links : TUPLE_KEYED_HASH_TABLE[BOOLEAN,TUPLE[STRING_8,STRING_8]]
			l_uuid : STRING_8
			l_isin : STRING_32
			l_security : RL_SECURITY
		do
			create l_response
			create l_nodes
			create l_links
			l_isin := a_request.string_32_value ("isin")
			l_uuid := a_request.string_8_value ("uuid")
			create l_seen_nodes.make (100)
			create l_seen_links.make (100)
			create l_response
			if attached l_isin then
				l_security := entities.barrid_securities.found_item(l_isin)
			end
			create l_response
			l_response.put(l_nodes,<<"nodes">>)
			l_response.put (l_links,<<"links">>)
			a_request.set_response (l_response)
		end

	handle_variable_expand(a_request : RL_REQUEST)
		local
			l_id : INTEGER
			l_response,l_structure : RL_JSON_STRUCTURE
			l_computations : RL_JSON_ARRAY
			l_computation :  separate RL_ENLIS_COMPUTATION[REAL_64]
			l_delimited : RL_DELIMITED_TEXT
			l_path,l_uuid : STRING_8
			l_file : RAW_FILE
		do
			l_path := a_request.string_8_value ("path")
			l_uuid := a_request.string_8_value ("uuid")
			create l_response
			if attached forecasts(l_uuid) as al_forecasts
			and then attached l_path then
				separate al_forecasts as s_forecasts do
					create l_delimited.make (l_path, ':')
					if attached l_delimited.last as al_last
					and then al_last.is_integer then
						l_id := al_last.to_integer
						if attached s_forecasts.computations[l_id] as al_computation then
							create l_computations.make_empty
							separate al_computation as s_computation do
								create l_computations.make_from_separate (s_computation.subexpressions_json(l_path))
							end
							l_response.put (l_computations, <<"subexpressions">>)
						end
					else
						l_response.put_string ("Unknown computation " + l_path, "Error")
					end
				end
			end
			a_request.set_response (l_response)
		end
	handle_set_valuation_parameters(a_request : RL_REQUEST)
		local
			l_cost_of_common_equity : REAL_64
			l_value_of_contingent_equity_class : REAL_64
			l_dilution_factor_for_splits : REAL_64
			l_cost_of_debt : REAL_64
			l_cost_of_preferred_stock : REAL_64
			l_cost_of_minority_interest : REAL_64
			l_after_tax_weighted_average_cost_of_capital : REAL_64
			l_valuation_parameters : RL_ENLIS_VALUATION_PARAMETERS
			l_company : RL_NA_COMPANY
		do
--			if attached a_request.string_32_value ("Ticker") as al_ticker then
--				create l_company.make (al_ticker)
--				create l_valuation_parameters.make (l_company, 2015, 5, create {RL_DATE}.make (2015,9,25))
--				l_valuation_parameters.set_cost_of_common_equity(a_request.real_64_value ("cost_of_common_equity"))
--				l_valuation_parameters.set_value_of_contingent_equity_class(a_request.real_64_value ("value_of_contingent_equity_class"))
--				l_valuation_parameters.set_dilution_factor_for_splits(a_request.real_64_value ("_dilution_factor_for_splits"))
--				l_valuation_parameters.set_cost_of_debt(a_request.real_64_value ("cost_of_debt"))
--				l_valuation_parameters.set_cost_of_preferred_stock(a_request.real_64_value ("cost_of_preferred_stock"))
--				l_valuation_parameters.set_cost_of_minority_interest(a_request.real_64_value ("cost_of_minority_interest"))
--				l_valuation_parameters.set_after_tax_weighted_average_cost_of_capital(a_request.real_64_value ("after_tax_weighted_average_cost_of_capital"))
--			end
		end
	handle_graph(a_request : RL_REQUEST)
		local
			l_response : RL_JSON_STRUCTURE
			l_nodes,l_links : RL_JSON_ARRAY
			l_node : RL_GRAPH_NODE
			l_link : RL_GRAPH_LINK
			l_id : INTEGER
			l_seen_nodes : RL_STRING_TABLE[BOOLEAN]
			l_seen_links : TUPLE_KEYED_HASH_TABLE[BOOLEAN,TUPLE[STRING_8,STRING_8]]
			l_uuid : STRING_8
		do
			create l_response
			create l_nodes
			create l_links
			l_id := a_request.integer_value ("id")
			l_uuid := a_request.string_8_value ("uuid")
			create l_seen_nodes.make (100)
			create l_seen_links.make (100)
			if attached l_uuid
			and then attached forecasts(l_uuid) as al_forecasts then
				separate al_forecasts as s_forecasts do
					if l_id > 0
					and then attached s_forecasts.computations[l_id] as al_variable then
						across al_variable.graph_nodes as ic_nodes loop
							if not l_seen_nodes[ic_nodes.item.id] then
								l_seen_nodes[ic_nodes.item.id] := True
								create l_node.make_from_separate (ic_nodes.item)
								l_nodes.extend (l_node.to_json)
							end
						end
						across al_variable.graph_links as ic_links loop
							create l_link.make_from_separate (ic_links.item)
							if not l_seen_links[[l_link.source.id,l_link.target.id]] then
								l_seen_links[[l_link.source.id,l_link.target.id]] := True
								l_links.extend (l_link.to_json)
							end
						end
					end
				end
			end
			l_response.put(l_nodes,<<"nodes">>)
			l_response.put (l_links,<<"links">>)
			a_request.set_response (l_response)
		end
	forecasts(a_uuid : detachable STRING_8) : detachable separate RL_ENLIS_FORECASTS
		do
			if attached a_uuid then
				separate forecasts_manager as s_forecasts_manager do
					Result := s_forecasts_manager.forecasts_table[a_uuid]
				end
			end
		end
	forecasts_manager :  separate RL_ENLIS_FORECAST_MANAGER
		once ("process")
			create Result
		end
	uuids : UUID_GENERATOR
		once
			create Result
		end
	description (a_uri : STRING_8) : STRING_8
		do
			Result := ""
		end
	statement_query : RL_POSTGRES_QUERY[RL_ULISSES_STATEMENT_RECORD,TUPLE[ticker : STRING_32;periodicity : STRING_32]]
		once
			create Result.make(ulisses_access.server,"select * from statements where ticker = $1 and sheet like $2 and end_date > '2010-01-01' order by row_index")
		end
	entities : RL_ENTITIES
		once
			create Result.make
		end
	statements : HASH_TABLE[RL_ULISSES_STATEMENT,STRING_8] attribute create Result.make (1000) end
	annual_statements_table : HASH_TABLE[like security_statements,STRING_8] attribute create Result.make(500) end
	quarterly_statements_table : HASH_TABLE[like security_statements,STRING_8] attribute create Result.make(500) end
	semiannual_statements_table : HASH_TABLE[like security_statements,STRING_8] attribute create Result.make(500) end
	c_annual : STRING_32 = "annual"
	c_quarterly : STRING_32 = "quarterly"
	c_semiannual : STRING_32 = "semiannual"

	security_statements(a_security : RL_SECURITY;a_periodicity : STRING_32) : detachable HASH_TABLE[RL_ULISSES_SHEET,STRING_32]
		local
			l_sheet_records : HASH_TABLE[RL_LIST[RL_ULISSES_STATEMENT_RECORD],RL_DATE]
			l_sheet : RL_ULISSES_SHEET
			l_items,l_records : RL_LIST[RL_ULISSES_STATEMENT_RECORD]
			l_ticker,l_variable,l_key,l_flag : STRING_32
			l_statement : RL_ULISSES_STATEMENT
			l_statements_table : HASH_TABLE[like security_statements,STRING_8]
			l_statement_records : HASH_TABLE[HASH_TABLE[RL_LIST[RL_ULISSES_STATEMENT_RECORD],RL_DATE],STRING_32]
			l_end_date : RL_DATE
		do
			if a_periodicity ~ c_annual then
				l_statements_table := annual_statements_table
				l_flag := "%%_Y"
			elseif a_periodicity ~ c_quarterly then
				l_statements_table := quarterly_statements_table
				l_flag := "%%_Q"
			elseif a_periodicity ~ c_semiannual then
				l_statements_table := semiannual_statements_table
				l_flag := "%%_S"
			else
				l_flag := ""
			end
			if attached l_statements_table then
				Result := l_statements_table[a_security.id]
				if not attached Result then
					create Result.make(40)
					l_statements_table[a_security.id] := Result
					across a_security.bloomberg_ids as ic_tickers loop
						l_ticker := ic_tickers.item.key
						l_items := statement_query.retrieved([l_ticker,l_flag])
						create l_statement_records.make (10)
						across l_items as ic_items loop
							l_end_date := ic_items.item.end_date
							l_sheet_records := l_statement_records[ic_items.item.sheet]
							if not attached l_sheet_records then
								create l_sheet_records.make (10)
								l_statement_records[ic_items.item.sheet] := l_sheet_records
							end
							l_records := l_sheet_records[l_end_date]
							if not attached l_records then
								create l_records
								l_sheet_records[l_end_date] := l_records
							end
							l_records.extend (ic_items.item)
						end
						across l_statement_records as ic_records loop
							l_key := ic_records.key
							create l_sheet.make (l_key)
							across ic_records.item as ic_sheets loop
								create l_statement.make (a_security, l_sheet, ic_sheets.key, ic_sheets.item)
								statements[l_statement.uuid] := l_statement
								l_sheet.statements[ic_sheets.key] := l_statement
								l_key := l_sheet.name
							end
							Result[l_key] := l_sheet
						end
					end
				end
			end
		end
	format_double : FORMAT_DOUBLE once create Result.make(10,3) end
end
