note
	description: "Summary description for {RL_HTML_PARSER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_HTML_PARSER
inherit
	XML_STANDARD_PARSER
		rename
			reset as xml_standard_parser_reset
		redefine
			make,
			parse_from_string_32
		end
create
	make
feature
	make
		do
			Precursor
			create ki_callbacks
			set_callbacks(ki_callbacks)
		end
	parse_from_string_32 (a_string: READABLE_STRING_32)
		do
			content_saved := Void
			Precursor(a_string)
			content_saved := Void
		rescue
			content_saved := a_string
		end
	ki_callbacks : RL_HTML_CALLBACKS
	reset
		do
			xml_standard_parser_reset
			create ki_callbacks
			set_callbacks(ki_callbacks)
		end
	content : STRING_32
		do
			if attached content_saved as al_content then
				Result := al_content
			else
				Result := ki_callbacks.content
			end
		end
	content_saved : detachable STRING_32

	html_safe_string (a_string: STRING_32): STRING_32
		do
			create Result.make (a_string.count + a_string.count // 10)
			across a_string as ic_string loop
				inspect ic_string.item
				when '&' then
					Result.append ("&amp;")
				when '<' then
					Result.append ("&lt;")
				when '>' then
					Result.append ("&gt;")
				when '"' then				-- These two only needed in HTML attributes, but not going to parse to that level for pre-process.
					Result.append ("&quot;")
				when '%'' then
					Result.append ("&#39;")
				else
					Result.extend (ic_string.item)
				end
			end
		end
end
