note
	description: "Summary description for {RL_D3_AWARE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	RL_JAVASCRIPT_AWARE
feature
--	font_name (a_font : EV_FONT) : TUPLE[key : STRING_8;value : STRING_32]
--		do
--			Result := ["font-name",a_font.name]
--		end

--	font_family(a_font : EV_FONT) : TUPLE[key,value : STRING_8]
--		local
--			l_value : STRING_8
--		do
--			inspect a_font.family
--			when family_modern then
--				l_value := "fixed"
--			when family_sans then
--				l_value := "sans-serif"
--			when family_roman then
--				l_value := "serif"
--			when family_screen then
--				l_value := "screen"
--			when family_typewriter then
--				l_value := "typewriter"
--			end
--			Result := ["font-family",l_value]
--		end
--	font_style(a_font : EV_FONT) : TUPLE[key,value : STRING_8]
--		local
--			l_value : STRING_8
--		do
--			inspect a_font.shape
--			when shape_italic then
--				l_value := "italic"
--			when shape_regular then
--				l_value := "normal"
--			end
--			Result := ["font-style",l_value]
--		end
--	font_weight(a_font : EV_FONT) : TUPLE[key,value : STRING_8]
--		local
--			l_value : STRING_8
--		do
--			inspect a_font.weight
--			when weight_black then
--				l_value := "bolder"
--			when weight_bold then
--				l_value := "bold"
--			when weight_regular then
--				l_value := "normal"
--			when weight_thin then
--				l_value := "lighter"
--			end
--			Result := ["font-weight",l_value]
--		end
--	font_size(a_font : EV_FONT) : TUPLE[key,value : STRING_8]
--		do
--			Result := ["font-size",a_font.height_in_points.out + "pt"]
--		end

	safe_string (a_string: STRING_32): STRING_32
			-- Converts `a_string' to a JSON safe parsable format.
		do
			create Result.make (a_string.count)
			across a_string as ic_string loop
				inspect ic_string.item
				when '\' then
					Result.extend ('\')
					Result.extend ('\')
				when '/' then			-- Note: Included for completeness to the standard, though all known JSON parsers handle an unescaped /.
					Result.extend ('\')
					Result.extend ('/')
				when '"' then
					Result.extend ('\')
					Result.extend ('"')
				when '%B' then
					Result.extend ('\')
					Result.extend ('b')
				when '%F' then
					Result.extend ('\')
					Result.extend ('f')
				when '%N' then
					Result.extend ('\')
					Result.extend ('n')
				when '%R' then
					Result.extend ('\')
					Result.extend ('r')
				when '%T' then
					Result.extend ('\')
					Result.extend ('t')
				when '%U' then
					Result.append("\u0000")
				else
--					if ic_string.item.code < 127 and then
--					ic_string.item.code >= 32 then
						Result.extend (ic_string.item)
--					else
--						Result.append("\u" + ic_string.item.natural_32_code.to_hex_string)
--					end
				end
			end
		end

	safe_string_8 (a_string: STRING_8): STRING_8
			-- Converts `a_string' to a JSON safe parsable format.
		do
			create Result.make (a_string.count)
			across a_string as ic_string loop
				inspect ic_string.item
				when '\' then
					Result.extend ('\')
					Result.extend ('\')
				when '/' then			-- Note: Included for completeness to the standard, though all known JSON parsers handle an unescaped /.
					Result.extend ('\')
					Result.extend ('/')
				when '"' then
					Result.extend ('\')
					Result.extend ('"')
				when '%B' then
					Result.extend ('\')
					Result.extend ('b')
				when '%F' then
					Result.extend ('\')
					Result.extend ('f')
				when '%N' then
					Result.extend ('\')
					Result.extend ('n')
				when '%R' then
					Result.extend ('\')
					Result.extend ('r')
				when '%T' then
					Result.extend ('\')
					Result.extend ('t')
				when '%U' then
					Result.append("\u0000")
				else
--					if ic_string.item.code < 127 and then
--					ic_string.item.code >= 32 then
						Result.extend (ic_string.item)
--					else
--						Result.append("\u" + ic_string.item.natural_32_code.to_hex_string)
--					end
				end
			end
		end

	is_json_special_character (c: CHARACTER): BOOLEAN
			-- Control Characters
			-- 	%F  	Form feed
			-- 	%H  	backslasH
			--  %N  	Newline
			--  %R  	carriage Return
			--  %T  	horizontal Tab
			--  %B  	Backspace
		    --  /       Solidus
		    --  "       Quotation	
		do
			inspect c
			when '"', '%H' , '/', '%B', '%F', '%N', '%R', '%T' then -- '%H' = '\' =  reverse solidus
				Result := True
			else

			end
		end

   is_json_special_control (c: CHARACTER): BOOLEAN
           -- Control Characters
           -- \b\f\n\r\t
		do
			inspect c
			when 'b', 'f', 'n', 'r', 't' then
				Result := True
			else

			end
		end

	c_foreground_color : STRING_8 = "foreground_color"
	c_background_color : STRING_8 = "background_color"
	c_on_click : STRING_8 = "on_click"
	c_on_enter : STRING_8 = "on_enter"
end
